package rwd.abstractsyntax.spiderdiagram;

import java.util.Vector;

public class AndCompoundDiagram extends NaryCompoundDiagram {
	public AndCompoundDiagram(Vector diagrams, String name) {
		super(diagrams, name);
	}

	public void flatten() {
		super.flatten();
		Vector children = new Vector();
		AndCompoundDiagram acd;
		for (int i = 0; i < diagrams.size(); i++) {
			Diagram d = (Diagram) (diagrams.get(i));
			if (d instanceof AndCompoundDiagram) {
				acd = (AndCompoundDiagram) d;
				Vector grandchildren = acd.getChildren();
				for (int j = 0; j < grandchildren.size(); j++) {
					children.add(grandchildren.get(j));
				}
			} else {
				children.add(d);
			}
		}
		this.setChildren(children);
	}

	public boolean equals(Diagram d) {
		if (!(d instanceof AndCompoundDiagram)) {
			return false;
		}
		AndCompoundDiagram otherd = (AndCompoundDiagram) (d);
		return super.equals(otherd);
	}

	public String toString() {
		String result = "" + getName() + "(";
		for (int i = 0; i < diagrams.size() - 1; i++) {
			result = result + diagrams.get(i) + " and ";
		}
		result = result + "" + diagrams.get(diagrams.size() - 1) + ")";
		return result;
	}


	public Diagram getClone() {
		Vector children = new Vector();
		for (int i = 0; i < diagrams.size(); i++) {
			children.add(((Diagram) (diagrams.get(i))).getClone());
		}
		return new AndCompoundDiagram(children, getName());
	}
}
