package rwd.concretesyntax;

import java.util.*;

/**
 * @author Octavian Patrascoiu
 *
 */
public class Observable 
{
	/** Constructor */
	public Observable() {
	}
	
	//
	// Add/Delete observers
	//
	public void addObserver(Observer o) {
		observers.add(o);
	}
	public void addObservers(Collection os) {
		Iterator i = os.iterator();
		while (i.hasNext()) {
			Observer o = (Observer)i.next();
			addObserver(o);			
		}
	}
	public void deleteObserver(Observer o) {
		observers.remove(o);
	}
	public void deleteObservers() {
		observers.clear();
	}

	//
	// Get observers
	// 
	public Set getObservers() {
		return observers;
	}
		
	//
	// Notification
	//
	public void notifyObservers(Object arg) {
		if (observers == null) return;
		if (changed) {
			Iterator i = observers.iterator();
			while (i.hasNext()) {
				Observer o = (Observer)i.next();
				o.update(this, arg);		
			}
			changed = false;
		}
	}
	public void notifyObservers() {
		if (observers == null) return;
		if (changed) {
			Iterator i = observers.iterator();
			while (i.hasNext()) {
				Observer o = (Observer)i.next();
				o.update(this, null);		
			}
			changed = false;
		}
	}
	
	//
	// Changed flag
	//
	public void setChanged() {
		changed = true;
	}
	public void clearChanged() {
		changed = false;
	}
		
	/** Set of observers */
	protected Set observers = new LinkedHashSet();
	/** Flag to check if is changed */
	protected boolean changed = false;
}
