package rwd.concretesyntax.eulerdiagram;

import java.util.Vector;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

/**
 * @author Octavian Patrascoiu
 *
 */
public class ConcreteContourSet
	implements java.io.Serializable 
{   
	public ConcreteContourSet() {
	}

	public ConcreteContourSet(Collection contours) {
		_contours = new Vector(contours);
	}
    
	public List getContours() {
		return _contours;
	}

	public void addContour(ConcreteContour c) {
		_contours.add(c);
	}

	public void addContours(Set set) {
		// remove any extra ones
		Iterator i = _contours.iterator();
		while (i.hasNext()) {
			ConcreteContour cc = (ConcreteContour) i.next();
			if (!set.contains(cc)) {
				removeContour(cc);
			}
		}
		// add any new ones
		i = set.iterator();
		while (i.hasNext()) {
			ConcreteContour cc = (ConcreteContour) i.next();
			if (!_contours.contains(cc)) {
				addContour(cc);
			}
		}
		
	}

	public void removeContour(ConcreteContour c) {
		_contours.remove(c);
	}
    
	public ConcreteContourSet getClone() {
		ConcreteContourSet res = new ConcreteContourSet();
		for(int i=0; i<_contours.size(); i++) {
			ConcreteContour item = (ConcreteContour)_contours.get(i);
			res.addContour((ConcreteContour)item.getClone());
		}
		return res;
	}
    
	// Local properties
	private List _contours = new Vector();
}
