package rwd.gui;

import java.util.Vector;

import java.awt.Rectangle;

public class ChoiceGetter {
	private Vector choicesMade = null;

	public synchronized Vector getChoice(
		final Rectangle forCenter,
		final String title,
		final Vector choices,
		final Vector defaultChoices,
		final boolean canChooseNone,
		final int selectionType) { //System.out.println("choices are "+choices);
		if (choices.size() == 0) {
			return new Vector();
		} else if (choices.size() == 1 && !canChooseNone) {
			return choices;
		}
		choicesMade = null;
		final ChoiceGetter thiscg = this;
		ChooserFromList list =
			new ChooserFromList(
				title,
				selectionType,
				choices,
				defaultChoices,
				thiscg,
				canChooseNone);
		Rectangle currentShape = list.getBounds();
		//int oldcentrex = (int) (currentShape.x + currentShape.width / 2);
		//int oldcentrey = (int) (currentShape.y + currentShape.height / 2);
		int newcentrex = (int) (forCenter.x + forCenter.width / 2);
		int newcentrey = (int) (forCenter.y + forCenter.height / 2);
		list.setBounds(
			(int) newcentrex - currentShape.width / 2,
			(int) newcentrey - currentShape.height / 2,
			currentShape.width,
			currentShape.height);
		list.show();
		try {
			wait();
		} catch (Exception e) { /**/
			System.out.println("exception e:" + e);
		}
		return choicesMade;
	}

	public synchronized void choiceMade(Vector items) {
		choicesMade = items;
		notifyAll();
	}

	public synchronized void formClosed() {
		notifyAll();
	}
}
