package rwd.gui;
import javax.swing.JFrame;
import java.awt.Font;
import java.awt.Component;
import javax.swing.JMenuBar;
import javax.swing.MenuElement;
import javax.swing.UIManager;
import javax.swing.SwingUtilities;

public class FontFrame extends JFrame {
	public FontFrame(String title) {
		super(title);
	}
	public void setFont(Font f) {
		super.setFont(f);
		Component[] things = getContentPane().getComponents();
		for (int i = 0; i < things.length; i++) {
			things[i].setFont(f);
		}
		JMenuBar jmb = getJMenuBar();
		if (jmb == null) { //System.out.println("empty menu bar");
		} else {
            MenuElement[] menus = jmb.getSubElements();
            changeFont(menus, f);
   		}

		try {
			FontSizeTheme laft = new FontSizeTheme();
			laft.setFont(f);
			javax.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme(laft);
			UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
			SwingUtilities.updateComponentTreeUI(getContentPane());
		} catch (Exception e) {
			System.out.println("Could not set look and feel: " + e);
		}
	}

	public void setDefaultCloseOperation(int s) {
		super.setDefaultCloseOperation(s);
	}
	public void repaint() {
		setFont(StaticObjects.getFont());
		super.repaint();
	}
	public void show() {
		setFont(StaticObjects.getFont());
		super.show();
	}
	public void pack() {
		setFont(StaticObjects.getFont());
		super.pack();               
	}
    private void changeFont(MenuElement[] menus,Font f){
        for(int i=0; i<menus.length; i++){
            MenuElement me = menus[i];
            me.getComponent().setFont(f);
            changeFont(me.getSubElements(),f);
        }        
    }
}
