package rwd.gui;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;

import javax.swing.JTree;
import javax.swing.SwingUtilities;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.JButton;
import javax.swing.tree.TreePath;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import java.util.Enumeration;

import rwd.abstractsyntax.spiderdiagram.AndCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.CompoundDiagram;
import rwd.views.abstracttoconcrete.forcemodel.SpiderPlacer;
import java.util.Vector;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
//import rwd.gui.editor.DiagramViewerComponent;
import rwd.gui.editor.viewers.DiagramViewerInterface;
import rwd.gui.editor.viewers.DiagramViewerComponent;

public class SmoothDiagramShowerTree{
    private DefaultTreeModel dtm;
    private DefaultMutableTreeNode selectedNode;
    private JTree tree;
    private final FontPanel treePanel;
    private final FontPanel allPanel;
    private JButton showPicture2 = new JButton("show picture");
    private final boolean diagramByDefault;
    private final boolean canSelect;
    private Diagram partDiagram;
    private Diagram diagram;
    private int diagramSize;
    private int jspSize;

    SmoothDiagramShowerTree(
        final FontPanel p,
        final Diagram d,
        boolean canSelect,
        boolean pictureByDefault,
        int diagramSize) {

        this.diagram = d;
        this.diagramSize = diagramSize;
        this.jspSize = (int)(diagramSize*1.1);
        this.partDiagram = d;
        this.diagramByDefault = pictureByDefault;
        this.canSelect = canSelect;
        allPanel = p;
        treePanel = new FontPanel();
        allPanel.removeAll();
        allPanel.setLayout(new BorderLayout());

        allPanel.add(treePanel, BorderLayout.CENTER);
        FontPanel tmp = new FontPanel();
        tmp.setLayout(new FlowLayout());
        showPicture2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                clickShowPicture(d);
            }
        });
        if (!pictureByDefault) {
            tmp.add(showPicture2);
        } else {
            clickShowPicture(d);
        }
        allPanel.add(tmp, BorderLayout.SOUTH);
        if (!(diagram instanceof UnitaryDiagram)) {
            showPicture2.setEnabled(false);
        }
        makeTree(d);
        allPanel.validate();
        allPanel.repaint();
    }
    private void clickShowPicture(Diagram d){
        try {
            makeTreeModel(d, true);
        } catch (IllegalArgumentException ex) {
        }        
    }
    
    public void repaintThings() { // who should call this - ProofViewer,...
        // iterate through thingsThatNeedRepainting
        SwingUtilities.invokeLater(new Runnable(){public void run(){
        try {
            for (int i = 0; i < thingsThatNeedRepainting.size(); i++) {
            	final DiagramViewerInterface dvc = 
                (DiagramViewerInterface) thingsThatNeedRepainting.get(i);
                dvc.fitToWidth(diagramSize);
                dvc.redrawImage();
//           		dvc.drawImageNow();
            }
            System.out.println("succeeded in repaintingimage");
        } catch (NullPointerException x) {
        }}});
    }

    Vector thingsThatNeedRepainting;

    private void makeTree(Diagram d) {
        thingsThatNeedRepainting = new Vector();
        //System.out.println("making a tree model of the diagram");
        dtm = makeTreeModel(d, diagramByDefault);
        //System.out.println("building a tree representation");
        tree = new JTree(dtm);
        //System.out.println("built a tree representation");
        // subclass TreeCellRenderer
        DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer() {
            public Component getTreeCellRendererComponent(
                JTree t,
                Object value,
                boolean selected,
                boolean expanded,
                boolean leaf,
                int row,
                boolean hasFocus) {

                if (value instanceof DefaultMutableTreeNode) {
                    Object userObject =
                        ((DefaultMutableTreeNode) value).getUserObject();
                    if (userObject instanceof DiagramViewerInterface) {
                        DiagramViewerInterface dvc =
                            (DiagramViewerInterface) userObject;
                        thingsThatNeedRepainting.add(dvc);
                        //JScrollPane jsp = new JScrollPane(dvc);
                        //jsp.setPreferredSize(new Dimension(jspSize,jspSize));
                        //return jsp;
                        dvc.setPreferredSize(new Dimension(jspSize,jspSize));
                        return (Component)dvc;
                    }
                }
                return super.getTreeCellRendererComponent(
                    t,
                    value,
                    selected,
                    expanded,
                    leaf,
                    row,
                    hasFocus);
            }
        };
        tree.setCellRenderer(renderer);

        tree.getSelectionModel().setSelectionPath(
            new TreePath(dtm.getPathToRoot(selectedNode)));
        //System.out.println("set selection path");
        final boolean canSelectF = canSelect;

        //Listen for when the selection changes.
        //System.out.println("adding selection listener");
        tree.addTreeSelectionListener(new TreeSelectionListener() {
            public void valueChanged(TreeSelectionEvent e) {
                //System.out.println("tree event e is "+e);
                DefaultMutableTreeNode node =
                    (DefaultMutableTreeNode) tree
                        .getLastSelectedPathComponent();
                try {
                    String name = (String) (node.getUserObject());
                    //System.out.println("clicked on "+name);
                    if (name.substring(0, 7).equals("name: '") && canSelectF) {
                        name = name.substring(7, name.length());
                        name = name.substring(0, name.indexOf("'"));
                        //System.out.println("select diagram: '"+name+"'");
                        selectedNode = node;
                        tree.getSelectionModel().setSelectionPath(
                            new TreePath(dtm.getPathToRoot(selectedNode)));
                        StaticObjects.mdf.selectPart(name);
                        return;
                    }
                } catch (StringIndexOutOfBoundsException x) {
                } catch (NullPointerException x) {
                } catch (ClassCastException x) {
                }

                //System.out.println("is not a name");
                // want to reclick on selectedNode
                tree.getSelectionModel().setSelectionPath(
                    new TreePath(dtm.getPathToRoot(selectedNode)));
            }
        });

        refreshDiagram(false);
        //System.out.println("finished tree shower constructor");
    }

    private void refreshDiagram(boolean isdrawn) {
        Runnable r = new Runnable() {
            public void run() {
                    //System.out.println("started the refresh run");
    FontScrollPane treeView = new FontScrollPane(tree);
                //p.removeAll();
                //treeView.setBounds(0,0,p.getWidth(),p.getHeight());
                treeView.setBounds(
                    0,
                    0,
                    treePanel.getWidth(),
                    treePanel.getHeight());
                tree.setBounds(
                    0,
                    0,
                    treePanel.getWidth(),
                    treePanel.getHeight());
                treePanel.setLayout(new BorderLayout());
                treePanel.removeAll();
                treePanel.add(treeView);
                allPanel.removeAll();
                allPanel.setLayout(new BorderLayout());
                allPanel.add(treePanel, BorderLayout.CENTER);
                FontPanel tmp = new FontPanel();
                tmp.setLayout(new FlowLayout());
                if (!diagramByDefault) {
                    tmp.add(showPicture2);
                } else {
                    clickShowPicture(diagram);
                }
                allPanel.add(tmp, BorderLayout.SOUTH);
                if (!(diagram instanceof UnitaryDiagram)) {
                    //showPicture.setEnabled(false);
                    showPicture2.setEnabled(false);
                }
                //p.add(treePanel,BorderLayout.CENTER);
                allPanel.validate();
                allPanel.repaint();
                //System.out.println("finished the refresh run");
            }
        };
        //System.out.println("refreshing");
        if (isdrawn && SwingUtilities.isEventDispatchThread()) {
            System.out.println("refreshing "+this.hashCode()+" within event thread");
            //r.run();
            SwingUtilities.invokeLater(r);
        } else if (isdrawn && !SwingUtilities.isEventDispatchThread()) {
            System.out.println("refreshing "+this.hashCode()+" outside event thread");
            r.run();
            //SwingUtilities.invokeLater(r);
        } else if (!isdrawn && SwingUtilities.isEventDispatchThread()) {
            System.out.println("painting "+this.hashCode()+" within event thread");
            r.run();
            //SwingUtilities.invokeLater(r);
        } else if (!isdrawn && !SwingUtilities.isEventDispatchThread()) {
            System.out.println("painting "+this.hashCode()+" outside event thread");
            SwingUtilities.invokeLater(r);
        }
        repaintThings();
        allPanel.repaint();
    }

    public void refreshDiagramAfterEdit() { // 
        // check user objects of leaf nodes against existing Diagram
        String s = "name: '" + partDiagram.getName() + "'";
        // System.out.println("refreshing "+s);
        selectedNode.setUserObject(s);
        if (partDiagram instanceof UnitaryDiagram) {
            try {
                DiagramViewerInterface dvc =
                    new DiagramViewerComponent(640, 480, (UnitaryDiagram) partDiagram, true, true);
                dvc.redrawImage();
//                dvc.drawImageNow();
                dvc.fitToWidth(diagramSize);
                DefaultMutableTreeNode node = new DefaultMutableTreeNode(dvc);
                selectedNode.removeAllChildren();
                selectedNode.add(node);
            } catch (IllegalArgumentException x) {
                UnitaryDiagram ud = (UnitaryDiagram) partDiagram;
                // each child node of selectedNode needs checking against
                // the attributes of partDiagram
                DefaultMutableTreeNode node;
                Enumeration e = selectedNode.children();
                node = (DefaultMutableTreeNode) e.nextElement();
                node.setUserObject(fillOut("contours: " + ud.getCloneOfContourSet()));
                node = (DefaultMutableTreeNode) e.nextElement();
                node.setUserObject(fillOut("zones: " + ud.getCloneOfZoneSet()));
                node = (DefaultMutableTreeNode) e.nextElement();
                node.setUserObject(
                    fillOut("shaded zones: " + ud.getCloneOfShadedZones()));
                node = (DefaultMutableTreeNode) e.nextElement();
                node.setUserObject(fillOut("spiders: " + ud.getSpiders()));
            }
        }
        refreshDiagram(true);
        //System.out.println("finished refreshDiagramAfterEdit");
    }
    private String fillOut(String p) {
        while (p.length() < 80) {
            p = p + " ";
        }
        return p;
    }

    public void refreshDiagramAfterNewPartChosen(Diagram partDiagram) { // highlight new part
        // already done by TreeSelectionListener
        this.partDiagram = partDiagram;
        //System.out.println("part diagram name is "+partDiagram.getName());
    }

    private DefaultTreeModel makeTreeModel(
        Diagram d,
        boolean try4Pictures) { //

        //System.out.println("making treemodel for "+d.getName());
        DefaultMutableTreeNode root =
            new DefaultMutableTreeNode(fillOut("name: '" + d.getName() + "'"));
        DefaultTreeModel result = new DefaultTreeModel(root);
        if (d == partDiagram) {
            selectedNode = root;
        }
        if (d instanceof CompoundDiagram) {
            CompoundDiagram cd = (CompoundDiagram) d;
            DefaultMutableTreeNode composition = null;
            if (cd instanceof AndCompoundDiagram) {
                composition = new DefaultMutableTreeNode("and");
            } else {
                composition = new DefaultMutableTreeNode("or");
            }
            root.add(composition);
            Vector children = cd.getChildren();
            for (int i = 0; i < children.size(); i++) {
                Diagram child = (Diagram) children.get(i);
                DefaultTreeModel model1 = makeTreeModel(child, try4Pictures);
                composition.insert(
                    (DefaultMutableTreeNode) (model1.getRoot()),
                    i);
            }
        } else if (d instanceof UnitaryDiagram) {
            UnitaryDiagram ud = (UnitaryDiagram) d;
            try {
                DiagramViewerInterface dvc =
                    new DiagramViewerComponent(jspSize, jspSize, ud, true, true);  
                // added by pjm2
                SpiderPlacer sp = new SpiderPlacer(dvc);
                sp.embed();
                // end
                    
                dvc.fitToWidth(diagramSize);
                root.add(new DefaultMutableTreeNode(dvc));
            } catch (IllegalArgumentException x) {
                root.add(
                    new DefaultMutableTreeNode(
                        fillOut("contours: " + ud.getCloneOfContourSet())));
                root.add(
                    new DefaultMutableTreeNode(
                        fillOut("zones: " + ud.getCloneOfZoneSet())));
                root.add(
                    new DefaultMutableTreeNode(
                        fillOut("shaded zones: " + ud.getCloneOfShadedZones())));
                root.add(
                    new DefaultMutableTreeNode(
                        fillOut("spiders: " + ud.getSpiders())));
            }
        }
        return result;
    }
}
