package rwd.gui.editor;

import javax.swing.filechooser.FileFilter;
import java.util.*;
import java.io.File;

public class EditorFileFilter extends FileFilter {
    
    public EditorFileFilter(String description) {
        _description = description;
    }
    
    public void addExtension(String extension) {
        _extensions.add("." + extension.toLowerCase());
    }
    
    public String getFirstExtension() {
        String extension = (String) _extensions.get(0);
        return extension.substring(1);
    }
    
    public boolean accept(File file) {
        if (file.isDirectory()) {
            return true;
        }
        String filename = file.getName().toLowerCase();
        for (int i = 0; i < _extensions.size(); i++) {
            String extension = (String) _extensions.get(i);
            if (filename.endsWith(extension)) {
                return true;
            }
        }
        return false;
    }
    
    public String getDescription() {
        return _description;
    }
    
    private Vector _extensions = new Vector();
    private String _description;
    
}
