package rwd.gui.editor.dialogs;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JTextField;

import rwd.tableaux.semantic.MatrixPanel;

import uk.ac.kent.cs.kmf.util.ILog;

/**
 * @author Octavian Patrascoiu
 *
 */
public class AddPointsToDiagramDialog
	extends JDialog
{
	public AddPointsToDiagramDialog(JFrame parent, String title, ILog log) {
		super(parent, title);	
		getContentPane().setLayout(new GridBagLayout());
		this.log = log;
		JDialog dialog = new JDialog();

		//
        // Create and fill NUMBERS panel
        //
		numberPanel = new MatrixPanel();
		// Add labels
		int line = 0;
		int column = 0;
		numberPanel.addLabel("Unitary diagram", line, column);
		diagramField = numberPanel.addTextField("d1", line, column+1);
		line++;
		numberPanel.addLabel("Minimum number of points", line, column);
		numPointsField = numberPanel.addTextField("8", line, column+1);
		line++;
		numberPanel.addLabel("Equalise number of points", line, column);
		eqPointsCheck = new JCheckBox();
		eqPointsCheck.setSelected(true);
		numberPanel.add(eqPointsCheck, line, column+1);
		    
		//
        // Create and fill CONFIRM panel 
        //
        MatrixPanel confirmPanel = new MatrixPanel();
        // OK button 
		JButton okButton = confirmPanel.addButton("OK", 0, 0);
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okAction(evt);
            }
        });
        // Cancel button 
		JButton cancelButton = confirmPanel.addButton("Cancel", 0, 1);
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelAction(evt);
            }
        });

	    // Add TAB panel to MAIN panel
		GridBagConstraints c = new GridBagConstraints(); 
	    c.gridx = 0;
	    c.gridy = 0;
		getContentPane().add(numberPanel, c);

		// Add CONFIRM to MAIN panel 		
	    c.gridx = 0;
	    c.gridy = 1;
	    c.anchor = GridBagConstraints.CENTER;
	    getContentPane().add(confirmPanel, c);
    		
        // Put frame in the middle of the screen
        pack();
        Dimension screen = getToolkit().getScreenSize();
        int width  = this.getSize().width+20;
        int height = this.getSize().height+20;
        int left = (screen.width - width)/2;
        int top = (screen.height - height)/2;
        setBounds(left, top, width, height);
	}

	// OK action 
	protected int returnVal = JFileChooser.CANCEL_OPTION;
    protected void okAction(java.awt.event.ActionEvent evt) {
    	returnVal = JFileChooser.APPROVE_OPTION;
		dispose();
    }

	// Cancel action 
    protected void cancelAction(java.awt.event.ActionEvent evt) {
		returnVal = JFileChooser.CANCEL_OPTION;   	
    	dispose();
    }

	// Get XMI file name -
	public int showOpenDialog(JFrame parent) {
		this.setModal(true);
		show();
		return returnVal;
	}
	
	// Get the numbers -
	public String getDiagramName() {
		String text = diagramField.getText();
		return text; 
	}
	public int getPointNum() {
		String text = numPointsField.getText(); 
		return Integer.parseInt(text);
	}
	public boolean isEqualised() {
		return eqPointsCheck.isSelected();
	}
	
	protected MatrixPanel numberPanel;
	protected JTextField diagramField;
	protected JTextField numPointsField;
	protected JCheckBox eqPointsCheck;

	protected ILog log;
}
