package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import rwd.concretesyntax.constraintdiagram.ConcreteArc;
import rwd.gui.editor.DiagramCanvas;
import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class DrawNewArcListener implements ActionListener {
	public DrawNewArcListener(EditorFrame frame, int type) {
		this.frame = frame;
		this.type = type;
	}
	
	public DrawNewArcListener(DiagramViewerInterface viewer, int type) {
		this.viewer = viewer;
		this.type = type;
	}

	public void actionPerformed(ActionEvent e) {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		DiagramCanvas dc = viewer.getDiagramCanvas();
		if (dc == null) return;
		int x = (int)dc.getCurrentX();
		int y = (int)dc.getCurrentY();
		addNewArc(type, x, y);
	}

	public void addNewArc(int type, int x, int y) {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		// Create an arc
		ConcreteArc arc = new ConcreteArc(type, x, y);
		arc.attachEnds(viewer);
		viewer.add(arc);
				
		// Repaint image
		viewer.redrawImage();
	}
	
	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
	private int type;
}


