package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class EditCopyCutPasteListener implements ActionListener {
	public EditCopyCutPasteListener(EditorFrame frame, int kind) {
		this.frame = frame;
		this.kind = kind;
	}
	
	public EditCopyCutPasteListener(DiagramViewerInterface viewer, int kind) {
		this.viewer = viewer;
		this.kind = kind;
	}

	public void actionPerformed(ActionEvent e) {
		copyCutPaste(kind);
	}

	public void copyCutPaste(int kind) {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		if (kind == COPY) {
			viewer.copySelectedItems();			
		} else if (kind == CUT) {
			viewer.cutSelectedItems();			
		} else if (kind == PASTE) {
			viewer.pasteSelectedItems();			
		}
		// Repaint image
		viewer.redrawImage();
	}

	// Local variables
	public static final int COPY = 1;
	public static final int CUT = 2;
	public static final int PASTE = 3;
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
	private int kind;
}

