package rwd.gui.editor.listeners;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JColorChooser;
import javax.swing.JComponent;

import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class FormatBackColorListener implements ActionListener {
	public FormatBackColorListener(EditorFrame frame) {
		this.frame = frame;
	}
	
	public FormatBackColorListener(DiagramViewerInterface viewer) {
		this.viewer = viewer;
	}

	public void actionPerformed(ActionEvent e) {
		setBackColor();
	}

	public void setBackColor() {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		Color color = JColorChooser.showDialog(
			(JComponent)viewer,
			"Choose background colour",
			Color.WHITE);
		if (color != null)
			viewer.setBackColor(color);

		viewer.redrawImage();
	}

	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
}

