package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.Options;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class FormatEllipseListener implements ActionListener {
	public FormatEllipseListener(EditorFrame frame) {
		this.frame = frame;
	}
	
	public FormatEllipseListener(DiagramViewerInterface viewer) {
		this.viewer = viewer;
	}

	public void actionPerformed(ActionEvent e) {
		smooth();
	}

	public void smooth() {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		Options opts = EditorFrame.options; 
		if (opts.isAsEllipse() == true) {
			opts.setAsEllipse(false);
		} else {
			opts.setAsEllipse(true);
		}

		viewer.redrawImage();
	}

	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
}
