package rwd.gui.editor.listeners;

import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFileChooser;

import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.dialogs.FontDialog;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class FormatFontListener implements ActionListener {
	public FormatFontListener(EditorFrame frame) {
		this.frame = frame;
	}
		
	public FormatFontListener(DiagramViewerInterface viewer) {
		this.viewer = viewer;
	}
	
	public void actionPerformed(ActionEvent e) {
		setFont();
	}
	
	public void setFont() {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		// Choose font
		FontDialog dialog = new FontDialog(frame, "Font");
		int returnVal = dialog.showOpenDialog(frame); 
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			Font font = dialog.getFont();
			// Set font
			viewer.setFont(font);
			// Repaint image
			viewer.redrawImage();
		}			
	}
	
	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
}
