package rwd.gui.editor.listeners;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JColorChooser;
import javax.swing.JComponent;

import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class FormatForeColorListener implements ActionListener {
	public FormatForeColorListener(EditorFrame frame) {
		this.frame = frame;
	}
	
	public FormatForeColorListener(DiagramViewerInterface viewer) {
		this.viewer = viewer;
	}

	public void actionPerformed(ActionEvent e) {
		setForeColor();
	}
	
	public void setForeColor() {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		Color color = JColorChooser.showDialog(
				(JComponent)viewer,
				"Choose foreground colour",
				Color.BLACK);
		viewer.setForeColor(color);

		viewer.redrawImage();
	}

	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
}
