package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JOptionPane;

import rwd.gui.editor.EditorFrame;
import rwd.ocl.eulerdiagram.EulerDiagram2Uml;

/**
 * @author Octavian Patrascoiu
 *
 */
public class MapEd2UmlListener implements ActionListener {
	public MapEd2UmlListener(EditorFrame frame) {
		this.frame = frame;
	}

	public void actionPerformed(ActionEvent e) {
		String inputString =
			JOptionPane.showInputDialog(
				frame,
				"Please enter logical expression",
				"d1");

		if (inputString != null) {
			// Get all the abstract unitary diagrams
			List cds = frame.getConcreteDiagrams(frame.getDesktopPane());

			// Reset log
			frame.getLog().reset();

			// Create an OCL generator
			EulerDiagram2Uml gen = new EulerDiagram2Uml(cds, frame.getLog());

			// Generate the corresponding XMI
			String oclXMI = gen.makeXMI(inputString);

			// Print it out
			frame.getLog().reportMessage(oclXMI);
		}
	}

	// Local variables
	protected EditorFrame frame;
}
