package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.gui.editor.EditorFrame;
import rwd.ocl.eulerdiagram.Uml2EulerDiagram;

/**
 * @author Octavian Patrascoiu
 *
 */
public class MapUml2EdListener implements ActionListener {
	public MapUml2EdListener(EditorFrame frame) {
		this.frame = frame;
	}

	public void actionPerformed(ActionEvent e) {
		// Show dialog to choose 
		int returnVal = frame.getInputChooser().showOpenDialog(frame);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File inputFile = frame.getInputChooser().getSelectedFile();
			String inputString = inputFile.getAbsolutePath();
			if (inputString != null) {
				// Create a uml to euler digram translator
				Uml2EulerDiagram gen = new Uml2EulerDiagram(frame.getLog());

				// Generate the corresponding Spider Diagram
				UnitaryDiagram ud = gen.makeEulerDigram(inputString);
				if (frame.showAbstractDiagram(ud, true, false) == null) {
					JOptionPane.showMessageDialog(frame, "Can't be drawn");
				}
			}
		}
	}

	// Local variables
	protected EditorFrame frame;
}
