package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import rwd.concretesyntax.spiderdiagram.ConcreteSpiderFeetAndLegsSet;
import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class PlaceFeetListener implements ActionListener {
	public PlaceFeetListener(EditorFrame frame) {
		this.frame = frame;
	}
	
	public PlaceFeetListener(DiagramViewerInterface viewer) {
		this.viewer = viewer;
	}

	public void actionPerformed(ActionEvent e) {
		placeFeet();
	}

	public void placeFeet() {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		java.util.List zoneAreas = new Vector(viewer.getConcreteDiagram().getVisibleConcreteZones());
		java.util.List spiderFeet = viewer.getConcreteDiagram().getFeetAndLegsSet().getFeet();
		new ConcreteSpiderFeetAndLegsSet(null).placeNodes(zoneAreas, spiderFeet,false, null);
		viewer.redrawImage();
	}
	
	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
}

