package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;
import java.util.Iterator;

import javax.swing.JOptionPane;

import rwd.abstractsyntax.spiderdiagram.DiagramFileUser;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.gui.ProofViewer;
import rwd.gui.editor.EditorFrame;
import rwd.rules.NoProofException;
import rwd.rules.Proof;
import rwd.rules.heuristics.HeuristicCalculatorOptimistic;
import rwd.rules.heuristics.HeuristicProofWriter;

/**
 * @author Octavian Patrascoiu
 *
 */
public class ReasoningProofListener implements ActionListener {
    public ReasoningProofListener(EditorFrame frame) {
        this.frame = frame;
    }

    public void actionPerformed(ActionEvent e) {
        String d1String =
            JOptionPane.showInputDialog(
                frame,
                "Please enter name of premise",
                "d1");
        String d2String =
            JOptionPane.showInputDialog(
                frame,
                "Please enter name of conclusion",
                "d2");
        /*ConcreteUnitaryDiagram cud1 = frame.getCUDCalled(d1String);
        if (cud1 == null) {
        	JOptionPane.showMessageDialog(
        		frame,
        		"can't identify unitary diagram called " + d1String);
        	return;
        }
        ConcreteUnitaryDiagram cud2 = frame.getCUDCalled(d2String);
        if (cud2 == null) {
        	 JOptionPane.showMessageDialog(
        		frame,
        		"can't identify unitary diagram called " + d2String);
        	 return;
        }*/

        //this throws exception if one spider has two feet
        //in the same zone - catch gracefully
        // 8th Dec                 

        //new SpiderFeetMapper().getFootMapping(cud1,cud2);

        UnitaryDiagram ud1 = frame.getUDCalled(d1String);
        if (ud1 == null) {
            JOptionPane.showMessageDialog(
                frame,
                "can't identify unitary diagram called " + d1String);
            return;
        }

        UnitaryDiagram ud2 = frame.getUDCalled(d2String);
        if (ud2 == null) {
            JOptionPane.showMessageDialog(
                frame,
                "can't identify unitary diagram called " + d2String);
            return;
        }
        System.out.println("ud1 is " + DiagramFileUser.toSaveString(ud1));
        System.out.println("ud2 is " + DiagramFileUser.toSaveString(ud2));
        try {
            Vector result =
                HeuristicProofWriter.seekProof(
                    ud1,
                    ud2,
                    6,
                    new HeuristicCalculatorOptimistic(),
                    null,
                    HeuristicProofWriter.unitaryHRules,
                    null,
                    true,
                    false,
                    true);
            Iterator i = result.iterator();
            while (i.hasNext()) {
                Object o = i.next();
                //System.out.println("got proof?" + o.getClass() + ":" + o);

                if (o instanceof Proof) {
                    Proof p = (Proof) o;
                    if (p == null) {
                        throw new NoProofException("no proof");
                    }
                    ProofViewer pv = new ProofViewer(p, false, true);
                    pv.show();
                }
            }
        } catch (NoProofException x) {
            JOptionPane.showMessageDialog(frame, "no proof found");
        }
    }

    // Local variables
    protected EditorFrame frame;
}
