package rwd.gui.editor.readers;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLReaderFactory;

import rwd.concretesyntax.ConcreteDiagram;

/**
 * @author Octavian Patrascoiu
 *
 */
public class XmlReader 
	implements DiagramReader
{
	// Read a list of abstract diagrams
	public void read(String xmlFileName) {
		try {
			//--- Create the XMLReader ---
			String parserClassName = "org.apache.xerces.parsers.SAXParser";
			XMLReader reader = XMLReaderFactory.createXMLReader(parserClassName);
			//--- Create and register the ContentHandler ---
			xmlHandler = new XmlHandler(this);
			reader.setContentHandler(xmlHandler);
			//--- Parse ---
			InputSource inputSource = new InputSource("file:///"+xmlFileName);
			reader.parse(inputSource);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/** Get the result of the read */
	public String getTitle() {
		return title;
	}
	public ConcreteDiagram getConcreteDiagram() {
		return diagram;
	}

	// Local variables
	protected XmlHandler xmlHandler;
	protected String title;
	protected ConcreteDiagram diagram;
}
