package rwd.gui.editor.viewers;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Rectangle;
import java.util.Vector;
import java.util.Set;

import rwd.abstractsyntax.spiderdiagram.Spider;
import rwd.concretesyntax.ConcreteDiagram;
import rwd.concretesyntax.ConcreteUnitaryDiagram;
import rwd.concretesyntax.DiagramItem;
import rwd.concretesyntax.constraintdiagram.ConcreteArcEnd;
import rwd.concretesyntax.eulerdiagram.DecorationBox;
import rwd.gui.editor.ControlPanel;
import rwd.gui.editor.DiagramCanvas;
import rwd.gui.editor.History;

/**
 * @author jaf28
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public interface DiagramViewerInterface 
{
	public String getTitle();
	public void setTitle(String title);

	public ConcreteDiagram getConcreteDiagram();
	public void setConcreteDiagram(ConcreteDiagram cd);
	public ConcreteUnitaryDiagram getCUDCalled(String name);

	public Set getContradictionZones();
	public void setContradictionZones(Set contZones);
	
	public History getHistory();
	
	public boolean isBezier();
	public void setBezier(boolean smoothed);

	public void setMotionFlag(boolean b);
	public boolean getMotionFlag();
    
	public void setBackColor(Color color);
	public void setForeColor(Color color);	
	public void setFont(Font font);	
    
	public ControlPanel getControlPanel();
	public DiagramCanvas getDiagramCanvas();
	
	public void fitToWidth(int width);
	public void setPreferredSize(Dimension d);
	public Rectangle getBoxAround(double padding);
	public DecorationBox getBoxAround(Set contours, double padding);
	public DiagramItem getNearestItem(float x, float y);
	public void attachArcEnd(ConcreteArcEnd arcEnd);
	public void attachArcs(boolean condition);
	public void updateArcsLocation();

	public void add(DiagramItem item);
	public void addWithoutHistory(DiagramItem item);
	public void addSpider(Vector zoneAreas, Spider spider);
	public void remove(DiagramItem item);	

	public java.util.List getSelectedItems();
	public void deleteSelectedItems();
	public void copySelectedItems();
	public void cutSelectedItems();
	public void pasteSelectedItems();

	public void changeType();
	public void setLabel(String label);
	public void setThickness(float thickness);

	public void undo();
	public void redo();
	public void store();

	// Drawing methods
	public void draw(ConcreteDiagram cd);
	public void redrawImage();
}
