package rwd.metrics;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.List;

import rwd.concretesyntax.ConcreteUnitaryDiagram;

/**
 * @author Octavian Patrascoiu
 *
 */
public class MetricsEvaluator {
	// Constructor
	public MetricsEvaluator(ConcreteUnitaryDiagram cud, List metrics) {
		this.cud = cud;
		this.metrics = metrics;
	}
	
	// Evaluate
	public String evaluate() {
		String res = "";
		double total = 0;
		for(int i=0; i<metrics.size(); i++) {
			Metric m = (Metric)metrics.get(i);
			double d = m.measure();
			total += d;
			res += m.getClass().getName().substring(12) + ":\t" + formatter.format(d) + "\n";
		}
		res += "Total:\t\t"+formatter.format(total);
		return res;	
	}
		
	// Local properties
	protected ConcreteUnitaryDiagram cud;
	protected List metrics;
	protected NumberFormat formatter = new DecimalFormat("000000.000000000");
}
