package rwd.metrics;

import java.awt.Polygon;
import java.util.Vector;
import java.util.Iterator;
import java.util.Set;

import rwd.concretesyntax.ConcreteUnitaryDiagram;
import rwd.concretesyntax.eulerdiagram.ConcreteZone;
import rwd.utilities.AreaRWD;
/*
 * 
 * @author jaf28
 * this throws an IllegalArgumentException if it's
 * asked to assess the ZoneRoundness where zones are not simply connected
 * (i.e. with diagrams which have underlying nested Euler diagrams)
 */

public class ZoneRoundness
	extends EulerMetric 
{
	public ZoneRoundness(ConcreteUnitaryDiagram cud, double weighting) {
		super(cud, weighting);
	}

	public double giveScore() {
		double score = 0.0;
        
        Set zonePolys = cud.getConcreteZones();
        Iterator i = zonePolys.iterator();
        while(i.hasNext()){
			ConcreteZone za = (ConcreteZone) i.next();
			AreaRWD a = za.getArea();
			Vector polys = AreaPolygonAdapter.getPolygonsFor(a);
			if(polys.size()!=1)
			{ throw new IllegalArgumentException(); }
			Polygon p = (Polygon)polys.get(0);
			score += ContourRoundnessAngle.giveShapeAngleScore(p);
		}
		return score;
	}

}
