package rwd.metrics.quality;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import rwd.concretesyntax.ConcreteUnitaryDiagram;

import uk.ac.kent.cs.kmf.util.ILog;

/**
 * @author Octavian Patrascoiu
 *
 */
public class QualityModel {
	//
	// Constructors
	//
	public QualityModel() {
	}
	public QualityModel(ConcreteUnitaryDiagram cud, List metrics, ILog log) {
		this.cud = cud;
		this.metrics = metrics;
		this.log = log;
	}
	
	//
	// Get/set methods
	//
	/** Set the list of metrics */
	public void setMetrics(List list) {
		this.metrics = list;
	}

	/** Get the list of metrics */
	public List getMetrics() {
		return metrics;
	}

		
	//
	// Local properties
	//
	/** Concrete unitary diagram */
	protected ConcreteUnitaryDiagram cud;
	/** List of metrics */
	protected List metrics = new Vector();
	/** Table to choose the appropiate evaluator */
	protected Map evaluators = new HashMap();
	/** Log file to report errors */
	protected ILog log;
}
