package rwd.ocl.constraintdiagram;

import java.util.*;

import rwd.concretesyntax.spiderdiagram.ConcreteSpider;

/**
 * @author Octavian Patrascoiu
 *
 */
public class Relation {
	public Relation(List nodes) {
		this.nodes = nodes;
		this.n = nodes.size();
		this.edges = new boolean[n][n];
	}
	
	public void addPair(Object node1, Object node2) {
		add(node1, node2);
	}
	protected void add(Object node1, Object node2) {
		int i = nodes.indexOf(node1);
		int j = nodes.indexOf(node2);
		edges[i][j] = true;
	}
	
	public boolean isEdge(Object node1, Object node2) {
		int i = nodes.indexOf(node1);
		int j = nodes.indexOf(node2);
		return edges[i][j];
	}
		
	public List getNodes() {
		return nodes;
	}	
	
	public List getNodes(Object node) {
		int i = nodes.indexOf(node);
		List res = new Vector();
		for(int j=0; j<n; j++) {
			if (edges[i][j]) {
				res.add(nodes.get(j));
			}
		}
		return res;
	}	

	public Relation closure() {
		Relation res = (Relation)this.clone();
		List nodes = res.getNodes();
		for(int j=0; j<n; j++) {
			for(int i=0; i<n; i++) {
				for(int k=0; k<n; k++) {
					if (edges[i][j] && edges[j][k]) {
						edges[i][k] = true;
					}
				}
			}
		}
		return res;
	}
	
	public Object clone() {
		List nodes = new Vector();
		nodes.addAll(getNodes());
		Relation res = new Relation(nodes);
		for(int i=0; i<n; i++) 
			for(int j=0; j<n; j++)
				res.edges[i][j] = edges[i][j]; 		
		return res;
	}
	
	public String toString() {
		String res = "";
		for(int i=0; i<n; i++) {
			ConcreteSpider sp1 = (ConcreteSpider)nodes.get(i);
			String label1 = sp1.getLabel();
			for(int j=0; j<n; j++) {
				if (edges[i][j]) {
					ConcreteSpider sp2 = (ConcreteSpider)nodes.get(j);
					String label2 = sp2.getLabel();
					res += "("+label1+", "+label2+")\n";
				}
			}
		}
		return res;
	}
	
	// Local properties
	protected List nodes = new Vector();
	protected int n = nodes.size();
	protected boolean edges[][];
}
