package rwd.rules.autoproof;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import java.util.Vector;
import rwd.rules.Proof;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.choicespec.RuleWithChoice;
import rwd.rules.choicespec.RuleReverseOrIdempotent;

public class DuplicatesRemover {
	public static Proof removeDupes(Diagram d) {
		Diagram diag = d.getClone();
		Proof p = new Proof(diag);
		RuleWithChoice r = (RuleWithChoice)RuleReverseOrIdempotent.getRule();
		partLoop : while (true) {
			Diagram part = r.findApplicablePart(diag);
			if (part == null) {
				break partLoop;
			}
			Vector specs = r.getApplicationPossibilities(part);
			RuleApplicationSpec spec = (RuleApplicationSpec) specs.get(0);
			diag = r.applyRuleToPart(diag, spec);
			p.addStepAtEnd(r, spec, diag);
		}
		return p;
	}
}
