package rwd.rules.autoproof;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.rules.Proof;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.application.RuleAppliesToJustADiagram;
import rwd.rules.nospec.NotFalseIsTrueRule;
import rwd.rules.nospec.NotTrueIsFalseComplexRule;
import rwd.rules.nospec.RemoveNotNotRule;
import rwd.rules.nospec.RemoveNotRuleComplex;

public class NotEliminator {
	public static Proof getRidOfNots(Diagram d) {
        Proof p = new Proof(d);
		//Diagram diag = d.getClone();
        // find leaves and apply RemoveNotNotRule
        Rule rnnr = RemoveNotNotRule.getRule();
        Rule rntf = NotTrueIsFalseComplexRule.getRule();
        Rule rnft = NotFalseIsTrueRule.getRule();
        Rule rnr = RemoveNotRuleComplex.getRule();
        boolean hasChanged = true;
        while(hasChanged){
            hasChanged = false;
            // look for app of NotTrueIsFalse
            Diagram part = rntf.findApplicablePart(d);
            while(part!=null){
                RuleApplicationSpec ras = new RuleAppliesToJustADiagram(part);
                Diagram newd = rntf.applyRuleToPart(d,ras);
                p.addStepAtEnd(rntf,ras,newd);
                //System.out.println("building sequence "+d.hashCode()+" "+ras.d.hashCode()+" "+newd.hashCode());
                d = newd;
                part = rntf.findApplicablePart(d);            
                hasChanged = true;
            }
            // look for app of NotFalseIsTrue
            part = rnft.findApplicablePart(d);
            while(part!=null){
                RuleApplicationSpec ras = new RuleAppliesToJustADiagram(part);
                Diagram newd = rnft.applyRuleToPart(d,ras);
                p.addStepAtEnd(rnft,ras,newd);
                //System.out.println("building sequence "+d.hashCode()+" "+ras.d.hashCode()+" "+newd.hashCode());
                d = newd;
                part = rnft.findApplicablePart(d);            
                hasChanged = true;
            }
            // look for app of RemoveNotNot
            part = rnnr.findApplicablePart(d);
            while(part!=null){
                RuleApplicationSpec ras = new RuleAppliesToJustADiagram(part);
                Diagram newd = rnnr.applyRuleToPart(d,ras);
                p.addStepAtEnd(rnnr,ras,newd);
                //System.out.println("building sequence "+d.hashCode()+" "+ras.d.hashCode()+" "+newd.hashCode());
                d = newd;
                part = rnnr.findApplicablePart(d);            
                hasChanged = true;
            }
            // look for app of RemoveNotRule
            part = rnr.findApplicablePart(d);
            while(part!=null){
                RuleApplicationSpec ras = new RuleAppliesToJustADiagram(part);
                Diagram newd = rnr.applyRuleToPart(d,ras);
                p.addStepAtEnd(rnr,ras,newd);
                //System.out.println("building sequence "+d.hashCode()+" "+ras.d.hashCode()+" "+newd.hashCode());
                d = newd;
                part = rnr.findApplicablePart(d);            
                hasChanged = true;
            }
        }
        //     
		return p;
	}
}
