package rwd.rules.choicespec;

import java.util.Vector;

import rwd.abstractsyntax.spiderdiagram.CompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.OrCompoundDiagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.abstractsyntax.spiderdiagram.AndCompoundDiagram;
import rwd.rules.application.RuleAppliesToDiagramAndDiagram;

public class RuleAndAbsorbtion extends RuleWithChoice {
    private RuleAndAbsorbtion() {
        super("sd: Pand(PorQ)->P");
    }
    private static Rule example = null;
    public static Rule getRule() {
        if (example == null) {
            example = new RuleAndAbsorbtion();
        }
        return example;
    }
    public boolean isInvertible() {
        return false;
    }

    public boolean canApplyTo(Diagram d) {
        Vector result = new Vector();
        // d must cast into an and-diagram
        if (d instanceof AndCompoundDiagram) {
            AndCompoundDiagram acd = (AndCompoundDiagram) d;
            Vector children = acd.getChildren();            
            Vector orChildren = new Vector();            
            for (int i = 0; i < children.size(); i++) {
                Diagram child = (Diagram) children.get(i);
                if(child instanceof OrCompoundDiagram){
                    orChildren.add(child);
                }
            }
            for (int i = 0; i < children.size(); i++) {
                Diagram child = (Diagram) children.get(i);
                // a candidate for P
                for (int j = 0; j < orChildren.size(); j++) {
                    // a candidate for P or Q
                    OrCompoundDiagram orChild = (OrCompoundDiagram) orChildren.get(j);
                    Vector orCChildren= orChild.getChildren();
                    for (int k = 0; k < orCChildren.size(); k++) {
                        Diagram orCChild = (Diagram) orCChildren.get(k);
                        if(child.equals(orCChild)){
                            return true;
                        }                        
                    }
                }
            }                        
        }
        return false;
    }

    public Vector getApplicationPossibilities(Diagram d) {
        Vector result = new Vector();
        // d must cast into an and-diagram
        if (d instanceof AndCompoundDiagram) {
            AndCompoundDiagram acd = (AndCompoundDiagram) d;
            Vector children = acd.getChildren();            
            Vector orChildren = new Vector();            
            for (int i = 0; i < children.size(); i++) {
                Diagram child = (Diagram) children.get(i);
                if(child instanceof OrCompoundDiagram){
                    orChildren.add(child);
                }
            }
            for (int i = 0; i < children.size(); i++) {
                Diagram child = (Diagram) children.get(i);
                // a candidate for P
                for (int j = 0; j < orChildren.size(); j++) {
                    // a candidate for P or Q
                    OrCompoundDiagram orChild = (OrCompoundDiagram) orChildren.get(j);
                    Vector orCChildren= orChild.getChildren();
                    for (int k = 0; k < orCChildren.size(); k++) {
                        Diagram orCChild = (Diagram) orCChildren.get(k);
                        if(child.equals(orCChild)){
                            result.add(new RuleAppliesToDiagramAndDiagram(d,orChild));
                        }                        
                    }
                }
            }                        
        }
        return result;
    }

    public Diagram applyRule(RuleApplicationSpec r) {
        RuleAppliesToDiagramAndDiagram radd =
            (RuleAppliesToDiagramAndDiagram) r;
        Diagram toRemove = radd.other;
        int[] coords = radd.d.getCoords(toRemove);
        Diagram outcome = radd.d.getClone();
        Diagram part = outcome.getPartAt(coords);
        Vector children = ((CompoundDiagram)outcome).getChildren();
        children.remove(part);
        if(children.size()==1){
            return (Diagram)children.get(0);
        } else {
            return outcome;
        }
    }
}
