/*
 * Created on 22-Nov-2003
 */
package rwd.rules.heuristics;

import java.util.Vector;
import java.util.HashMap;
import rwd.abstractsyntax.spiderdiagram.AndCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.CompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.DiagramFileUser;
import rwd.abstractsyntax.spiderdiagram.FalseDiagram;
import rwd.abstractsyntax.spiderdiagram.NotCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.OrCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.rules.Proof;
import rwd.rules.ProofGetterRandom;
import rwd.rules.Rule;
import rwd.rules.choicespec.RuleExcludedMiddle;
import rwd.rules.choicespec.RuleSplitSpider;
import rwd.rules.inputspec.RuleAddContour;
import rwd.rules.nospec.AndIdempotentRule;
import rwd.rules.nospec.OrIdempotentRule;

/**
 * @author jaf28
 * One component for a compound diagram heuristic
 */
public class CompoundAnd_OrNumMeasure {

    public static int getMeasure(Diagram d, boolean isAnd) {
        previousExamples.clear();
        //try{
        return getMeasureAlteringD((Diagram) d.getClone(), isAnd);
        //} catch(StackOverflowError x){
        //    System.out.println("stack overflow");
        //    System.exit(0);
        //}
        //return 0;
    }

    private static Vector previousExamples = new Vector();

    private static int getMeasureAlteringD(Diagram d, boolean isAnd) {
        Diagram forPrinting = (Diagram) d.getClone();

        for (int i = 0; i < previousExamples.size(); i++) {
            Diagram pe = (Diagram) previousExamples.get(i);
            if (pe.equals(d)) {
                System.out.println("stack overflow ahead");
                System.out.println(
                    "previous examples were " + previousExamples);
                System.out.println("this task is " + d);
                System.exit(0);
            }
        }
        previousExamples.add(d.getClone());

        boolean isDebug = false;

        if (isAnd) {
            if (isDebug) {
                System.out.print("finding AndNum ");
            }
        } else {
            if (isDebug) {
                System.out.print("finding OrNum ");
            }
        }
        if (isDebug) {
            System.out.println("diagram is " + DiagramFileUser.toSaveString(d));
        }

        if (d instanceof FalseDiagram) {
            if (isAnd) {
                if (isDebug) {
                    System.out.println("measure for " + d + " is infinity");
                }
                return Integer.MAX_VALUE;
            } else {
                if (isDebug) {
                    System.out.println("measure for " + d + " is 0");
                }
                return 0;
            }
        } else if (d instanceof UnitaryDiagram) {
            if (isDebug) {
                System.out.println("measure for " + d + " is 0");
            }
            return 0;
        } else if (d instanceof NotCompoundDiagram) {
            int result =
                getMeasureAlteringD(
                    (Diagram) (((NotCompoundDiagram) d).getChildren().get(0)),
                    !isAnd);
            if (isDebug) {
                System.out.println("measure for " + d + " is " + result);
            }
            return result;

        } else if (d instanceof CompoundDiagram) {
            if (isDebug) {
                System.out.println("example is compound");
            }
            CompoundDiagram cd = (CompoundDiagram) d;
            Vector children = cd.getChildren();
            if (isDebug) {
                System.out.println(
                    "example has " + children.size() + " children");
            }
            // count how many children are unitary and remove them
            int numUnitary = 0;
            Vector toRemove = new Vector();
            for (int i = 0; i < children.size(); i++) {
                Diagram child = (Diagram) children.get(i);
                if (child instanceof UnitaryDiagram
                    && !(child instanceof FalseDiagram)) {
                    toRemove.add(child);
                    numUnitary++;
                }
            }
            if (isDebug) {
                System.out.println(
                    "example has " + numUnitary + " unitary children");
                System.out.println(
                    "before removal, have " + children.size() + " children");
            }
            children.removeAll(toRemove);
            if (isDebug) {
                System.out.println(
                    "after, have " + children.size() + " children");
                System.out.println("cd's children are " + cd.getChildren());
            }

            // either we end up with no children : all were unitary
            if (children.size() == 0) {
                if (cd instanceof AndCompoundDiagram
                    && isAnd
                    || cd instanceof OrCompoundDiagram
                    && !isAnd) {
                    if (isDebug) {
                        System.out.println(
                            "all children were unitary : return "
                                + (numUnitary - 1));
                    }
                    return numUnitary - 1;
                } else {
                    if (isDebug) {
                        System.out.println(
                            "all children were unitary : return 0");
                    }
                    return 0;
                }
            } else if (children.size() == 1) {
                // or we end up with one child : all except one were unitary
                Diagram remainingChild = (Diagram) children.get(0);
                int result =
                    numUnitary + getMeasureAlteringD(remainingChild, isAnd);
                if (isDebug) {
                    System.out.println(
                        "one non-unitary child : return " + result);
                }
                return result;
            } else {
                if (numUnitary > 0) {
                    int result = numUnitary + getMeasureAlteringD(cd, isAnd);
                    if (isDebug) {
                        System.out.println(
                            "more than one non-unitary child : return "
                                + result);
                    }
                    return result;
                } else {
                    // get a child out
                    if (isDebug) {
                        System.out.println(
                            "has just "
                                + children.size()
                                + " compound children now");
                    }
                    Diagram child = (Diagram) children.get(0);
                    children.remove(child);
                    Diagram otherChild = (Diagram) children.get(0);
                    // it has no Unitary children - do max/min
                    if (isAnd
                        && cd instanceof AndCompoundDiagram
                        || (!isAnd && cd instanceof OrCompoundDiagram)) {
                        if (isDebug) {
                            System.out.println("do max");
                        }
                        if (children.size() == 1) {
                            if (isDebug) {
                                System.out.println("of the 2 children");
                            }
                            return Math.max(
                                getMeasure(child, isAnd),
                                getMeasure(otherChild, isAnd));
                        } else {
                            if (isDebug) {
                                System.out.println("of the child and the rest");
                            }
                            return Math.max(
                                getMeasure(child, isAnd),
                                getMeasure(cd, isAnd));
                        }
                    } else {
                        if (isDebug) {
                            System.out.println("do min");
                        }
                        if (children.size() == 1) {
                            if (isDebug) {
                                System.out.println("of the 2 children");
                            }
                            return Math.min(
                                getMeasure(child, isAnd),
                                getMeasure(otherChild, isAnd));
                        } else {
                            if (isDebug) {
                                System.out.println("of the child and the rest");
                            }
                            return Math.min(
                                getMeasure(child, isAnd),
                                getMeasure(cd, isAnd));
                        }
                    }
                }
            }
        }
        throw new IllegalArgumentException();
    }

    private static int andNumBefore, andNumAfter, orNumBefore, orNumAfter;
    private static Diagram start, end;
    private static boolean andNumUnchanged() {
        return andNumHasntGrown() && andNumHasntShrunk();
    }
    private static boolean orNumUnchanged() {
        return orNumHasntGrown() && orNumHasntShrunk();
    }
    private static boolean andNumHasntGrown() {
        return andNumBefore >= andNumAfter;
    }
    private static boolean orNumHasntGrown() {
        return orNumBefore >= orNumAfter;
    }
    private static boolean andNumHasntShrunk() {
        return andNumAfter >= andNumBefore;
    }
    private static boolean orNumHasntShrunk() {
        return orNumAfter >= orNumBefore;
    }
    private static boolean andNumHasntChangedByMoreThanOne() {
        return Math.abs(andNumAfter - andNumBefore) <= 1;
    }
    private static boolean orNumHasntChangedByMoreThanOne() {
        return Math.abs(orNumAfter - orNumBefore) <= 1;
    }

    private static void showreport(String message) {
        System.out.println(message);
        //System.out.println(
        //    "start diagram is " + DiagramFileUser.toSaveString(start));
        //System.out.println(
        //    "result diagram is " + DiagramFileUser.toSaveString(end));
        System.out.println("andNumBefore " + andNumBefore);
        System.out.println("andNumAfter " + andNumAfter);
        System.out.println("orNumBefore " + orNumBefore);
        System.out.println("orNumAfter " + orNumAfter);
    }

    public static void main(String args[]) {
        // build suitable rule set
        HashMap resultsHM = new HashMap();
        Vector HRules = HeuristicProofWriter.compoundHRules;
        Rule[] rules = new Rule[HRules.size()];
        for (int i = 0; i < HRules.size(); i++) {
            rules[i] = (Rule) HRules.get(i);
            resultsHM.put(rules[i].name, new Integer(0));
        }

        // build one-step proofs        
        ProofGetterRandom pgr1 = new ProofGetterRandom(2, 3, 2, 1, rules);
        ProofGetterRandom pgr2 = new ProofGetterRandom(1, 1, 2, 6, rules);
        ProofGetterRandom pgr3 = new ProofGetterRandom(0, 3, 2, 2, rules);

        // see how the measures change
        for (int i = 0; i < 500000; i++) {
            if (i % 10000 == 0) {
                System.out.println("" + i);
            }
            Proof p = null;
            if (i % 3 == 0) {
                p = pgr1.getProof(1);
            } else if (i % 3 == 1) {
                p = pgr2.getProof(1);
            } else {
                p = pgr3.getProof(1);
            }
            if (p.numSteps() == 0) {
                i--;
            } else {
                start = p.getFirstDiagram();
                end = p.getLastDiagram();
                andNumBefore = getMeasure(start, true);
                orNumBefore = getMeasure(start, false);
                andNumAfter = getMeasure(end, true);
                orNumAfter = getMeasure(end, false);
                Rule r = p.getImminentRule();
                // log which rules we have experienced
                resultsHM.put(
                    r.name,
                    new Integer(
                        ((Integer) (resultsHM.get(r.name))).intValue() + 1));
                // by default we expect the measure to be left unchanged
                if (andNumUnchanged() && orNumUnchanged()) {
                } else if (r instanceof RuleAddContour) {
                    if (andNumHasntShrunk()
                        && andNumHasntGrown()
                        && andNumHasntChangedByMoreThanOne()
                        && orNumHasntShrunk()
                        && orNumHasntGrown()
                        && orNumHasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof AndIdempotentRule) {
                    if (andNumHasntShrunk()
                        && andNumHasntGrown()
                        && andNumHasntChangedByMoreThanOne()
                        && orNumHasntShrunk()
                        && orNumHasntGrown()
                        && orNumHasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof OrIdempotentRule) {
                    if (andNumHasntShrunk()
                        && andNumHasntGrown()
                        && andNumHasntChangedByMoreThanOne()
                        && orNumHasntShrunk()
                        && orNumHasntGrown()
                        && orNumHasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof RuleSplitSpider) {
                    if (andNumHasntShrunk()
                        && andNumHasntGrown()
                        && andNumHasntChangedByMoreThanOne()
                        && orNumHasntShrunk()
                        && orNumHasntGrown()
                        && orNumHasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof RuleExcludedMiddle) {
                    if (andNumHasntShrunk()
                        && andNumHasntGrown()
                        && andNumHasntChangedByMoreThanOne()
                        && orNumHasntShrunk()
                        && orNumHasntGrown()
                        && orNumHasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else {
                    showreport(" unexpected change : " + r);
                }
            }
        }
        System.out.println("");
        for (int i = 0; i < HRules.size(); i++) {
            Rule r = (Rule) HRules.get(i);
            System.out.println("" + resultsHM.get(r.name) + " " + r.name);
        }
    }
}
