/*
 * Created on 22-Nov-2003
 *
 */
package rwd.rules.heuristics;


/**
 * @author jaf28
 * One component for a compound diagram heuristic
 */
public class CompoundShadingMeasure {
    // PLEASE REMOVE ME FROM CVS
/*
    public static Vector getMeasure(Diagram d, boolean isMeasure1) {
        return getMeasure(d, isMeasure1, d);
    }
    public static Vector getMeasure(
        Diagram d,
        boolean isMeasure1,
        Diagram context) {
        d = (Diagram) (d.getClone());
        context = (Diagram) (context.getClone());
        Vector allContours = new Vector();
        // find universal set of contours
        /*
        Vector leaves = d.getUnitaryParts();
        for (int i = 0; i < leaves.size(); i++) {
            UnitaryDiagram leaf = (UnitaryDiagram) leaves.get(i);
            if (!(leaf instanceof FalseDiagram)) {
                Vector contours = leaf.getContours();
                for (int j = 0; j < contours.size(); j++) {
                    Contour c = (Contour) contours.get(j);
                    if (!allContours.contains(c)) {
                        allContours.add(c);
                    }
                }
            }
        }
        Vector leaves2 = context.getUnitaryParts();
        for (int i = 0; i < leaves2.size(); i++) {
            UnitaryDiagram leaf = (UnitaryDiagram) leaves2.get(i);
            if (!(leaf instanceof FalseDiagram)) {
                Vector contours = leaf.getContours();
                for (int j = 0; j < contours.size(); j++) {
                    Contour c = (Contour) contours.get(j);
                    if (!allContours.contains(c)) {
                        allContours.add(c);
                    }
                }
            }
        }
        // turn to contour form
        contourFormLoop : while (true) {
            Vector leaves3 = d.getUnitaryParts();
            for (int i = 0; i < leaves3.size(); i++) {
                UnitaryDiagram leaf = (UnitaryDiagram) leaves3.get(i);
                if (!(leaf instanceof FalseDiagram)) {
                    Vector contours = leaf.getContours();
                    Vector otherCs = (Vector) allContours.clone();
                    otherCs.removeAll((Vector)contours.clone());
                    contours.removeAll((Vector)otherCs.clone());
                    if (otherCs.size() > 0) {
                        Contour toAdd = (Contour) otherCs.get(0);
                        d =
                            RuleAddContour.getRule().applyRuleToPart(
                                d,
                                new RuleAppliesWithString(
                                    leaf,
                                    toAdd.toString()));
                        continue contourFormLoop;
                    }
                    if (contours.size() > 0) {
                        Contour toRemove = (Contour) otherCs.get(0);
                        d =
                            RuleDeleteContour.getRule().applyRuleToPart(
                                d,
                                new RuleAppliesToContour(
                                    leaf,
                                    toRemove));
                        continue contourFormLoop;
                    }
                }
            }
            break contourFormLoop;
        }
        contourFormLoop : while (true) {
            Vector leaves4 = context.getUnitaryParts();
            for (int i = 0; i < leaves4.size(); i++) {
                UnitaryDiagram leaf = (UnitaryDiagram) leaves4.get(i);
                if (!(leaf instanceof FalseDiagram)) {
                    Vector contours = leaf.getContours();
                    Vector otherCs = (Vector) allContours.clone();
                    otherCs.removeAll(contours);
                    if (otherCs.size() > 0) {
                        Contour toAdd = (Contour) otherCs.get(0);
                        context =
                            RuleAddContour.getRule().applyRuleToPart(
                                context,
                                new RuleAppliesWithString(
                                    leaf,
                                    toAdd.toString()));
                        continue contourFormLoop;
                    }
                }
            }
            break contourFormLoop;
        }
        Vector allZones = UnitaryDiagram.allPossibleZones(allContours);
        // turn to venn form
        vennFormLoop : while (true) {
            Vector leaves5 = d.getUnitaryParts();
            for (int i = 0; i < leaves5.size(); i++) {
                UnitaryDiagram leaf = (UnitaryDiagram) leaves5.get(i);
                if (!(leaf instanceof FalseDiagram)) {
                    Vector zones = leaf.getZones();
                    Vector otherZones = (Vector) allZones.clone();
                    otherZones.removeAll(zones);
                    if (otherZones.size() > 0) {
                        Zone toAdd = (Zone) otherZones.get(0);
                        d =
                            RuleIntroduceShadedZone.getRule().applyRuleToPart(
                                d,
                                new RuleAppliesToZone(leaf, toAdd));
                        continue vennFormLoop;
                    }
                }
            }
            break vennFormLoop;
        }
        vennFormLoop : while (true) {
            Vector leaves = context.getUnitaryParts();
            for (int i = 0; i < leaves.size(); i++) {
                UnitaryDiagram leaf = (UnitaryDiagram) leaves.get(i);
                if (!(leaf instanceof FalseDiagram)) {
                    Vector zones = leaf.getZones();
                    Vector otherZones = (Vector) allZones.clone();
                    otherZones.removeAll(zones);
                    if (otherZones.size() > 0) {
                        Zone toAdd = (Zone) otherZones.get(0);
                        context =
                            RuleIntroduceShadedZone.getRule().applyRuleToPart(
                                context,
                                new RuleAppliesToZone(leaf, toAdd));
                        continue vennFormLoop;
                    }
                }
            }
            break vennFormLoop;
        }

        return getMeasure(d, allZones, isMeasure1);
    }

    private static Vector getMeasure(
        Diagram d,
        Vector universalSet,
        boolean isMeasure1) {

        boolean isDebug = false;

        if (isMeasure1) {
            if (isDebug) {
                System.out.print("finding Zone1 ");
            }
        } else {
            if (isDebug) {
                System.out.print("finding Zone2 ");
            }
        }
        if (isDebug) {
            System.out.println("diagram is " + d + " and U = " + universalSet);
        }

        if (d instanceof FalseDiagram) {
            if (isMeasure1) {
                if (isDebug) {
                    System.out.println(
                        "measure for " + d + " is " + universalSet);
                }
                return universalSet;
            } else {
                if (isDebug) {
                    System.out.println("measure for " + d + " is emptyset");
                }
                return new Vector();
            }
        } else if (d instanceof UnitaryDiagram) {
            Vector zones = ((UnitaryDiagram) d).getCloneOfShadedZones();
            if (isDebug) {
                System.out.println("measure for " + d + " is " + zones);
            }
            return zones;
        } else if (d instanceof NotCompoundDiagram) {
            Vector zones =
                getMeasure(
                    (Diagram) (((NotCompoundDiagram) d).getChildren().get(0)),
                    universalSet,
                    !isMeasure1);
            if (isDebug) {
                System.out.println("measure for " + d + " is " + zones);
            }
            return zones;

        } else if (d instanceof CompoundDiagram) {
            CompoundDiagram cd = (CompoundDiagram) d;
            Vector children = cd.getChildren();
            Vector measures = new Vector();
            for (int i = 0; i < children.size(); i++) {
                measures.add(
                    getMeasure(
                        (Diagram) (children.get(i)),
                        universalSet,
                        isMeasure1));
            }
            if (!isMeasure1
                && d instanceof AndCompoundDiagram
                || (isMeasure1 && d instanceof OrCompoundDiagram)) {
                // take intersection for C2
                if (isDebug) {
                    System.out.println("now take intersection");
                }
                Vector result = new Vector();
                Vector firstChildSet = (Vector) measures.get(0);
                for (int i = 0; i < firstChildSet.size(); i++) {
                    Zone z = (Zone) firstChildSet.get(i);
                    boolean isEverywhere = true;
                    for (int j = 1; j < measures.size(); j++) {
                        if (!((Vector) (measures.get(j))).contains(z)) {
                            isEverywhere = false;
                        }
                    }
                    if (isEverywhere) {
                        result.add(z);
                    }
                }
                if (isDebug) {
                    System.out.println("measure for " + d + " is " + result);
                }
                return result;
            } else {
                // take union for C1
                if (isDebug) {
                    System.out.println("now take union");
                }
                Vector result = new Vector();
                for (int j = 0; j < measures.size(); j++) {
                    Vector set = (Vector) measures.get(j);
                    for (int i = 0; i < set.size(); i++) {
                        Zone z = (Zone) set.get(i);
                        if (!result.contains(z)) {
                            result.add(z);
                        }
                    }
                }
                if (isDebug) {
                    System.out.println("measure for " + d + " is " + result);
                }
                return result;
            }
        }
        throw new IllegalArgumentException();
    }

    private static Vector sz1Before, sz1After, sz2Before, sz2After;
    private static Diagram start, end;
    private static boolean sz1Unchanged() {
        return sz1HasntGrown() && sz1HasntShrunk();
    }
    private static boolean sz2Unchanged() {
        return sz2HasntGrown() && sz2HasntShrunk();
    }
    private static boolean sz1HasntGrown() {
        return sz1Before.containsAll(sz1After);
    }
    private static boolean sz2HasntGrown() {
        return sz2Before.containsAll(sz2After);
    }
    private static boolean sz1HasntShrunk() {
        return sz1After.containsAll(sz1Before);
    }
    private static boolean sz2HasntShrunk() {
        return sz2After.containsAll(sz2Before);
    }
    private static boolean sz1HasntChangedByMoreThanOne() {
        return Math.abs(sz1After.size() - sz1Before.size()) <= 1;
    }
    private static boolean sz2HasntChangedByMoreThanOne() {
        return Math.abs(sz2After.size() - sz2Before.size()) <= 1;
    }

    private static void showreport(String message) {
        System.out.println(message);
        System.out.println(
            "start diagram is " + DiagramFileUser.toSaveString(start));
        System.out.println(
            "result diagram is " + DiagramFileUser.toSaveString(end));
        System.out.println("sz1Before " + sz1Before);
        System.out.println("sz1After " + sz1After);
        System.out.println("sz2Before " + sz2Before);
        System.out.println("sz2After " + sz2After);
    }

    public static void main(String args[]) {
        // build suitable rule set
        HashMap resultsHM = new HashMap();
        Vector HRules = HeuristicProofWriter.compoundHRules;
        Rule[] rules = new Rule[HRules.size()];
        for (int i = 0; i < HRules.size(); i++) {
            rules[i] = (Rule) HRules.get(i);
            resultsHM.put(rules[i].name, new Integer(0));
        }

        // build one-step proofs        
        ProofGetterRandom pgr1 = new ProofGetterRandom(2, 3, 2, 1, rules);
        ProofGetterRandom pgr2 = new ProofGetterRandom(1, 1, 2, 6, rules);
        ProofGetterRandom pgr3 = new ProofGetterRandom(0, 3, 2, 2, rules);

        // see how the measures change
        for (int i = 0; i < 500000; i++) {
            if (i % 10000 == 0) {
                System.out.println("" + i);
            }
            Proof p = null;
            if (i % 3 == 0) {
                p = pgr1.getProof(1);
            } else if (i % 3 == 1) {
                p = pgr2.getProof(1);
            } else {
                p = pgr3.getProof(1);
            }
            if (p.numSteps() == 0) {
                i--;
            } else {
                start = p.getFirstDiagram();
                end = p.getLastDiagram();
                sz1Before = getMeasure(start, true, end);
                sz2Before = getMeasure(start, false, end);
                sz1After = getMeasure(end, true, start);
                sz2After = getMeasure(end, false, start);
                Rule r = p.getImminentRule();
                // log which rules we have experienced
                resultsHM.put(
                    r.name,
                    new Integer(
                        ((Integer) (resultsHM.get(r.name))).intValue() + 1));
                // by default we expect the measure to be left unchanged
                if (sz1Unchanged() && sz2Unchanged()) {
/*
                } else if (r instanceof RuleAddContour) {
                    if (sz1HasntShrunk()
                        && sz1HasntGrown()
                        && sz1HasntChangedByMoreThanOne()
                        && sz2HasntGrown()
                        && sz2HasntShrunk()
                        && sz2HasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof RuleUnshadeZone) {
                    if (   sz1HasntGrown() // JM idea
                        && sz1HasntChangedByMoreThanOne()
                        && sz2HasntGrown()
                        && sz2HasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof RuleExcludedMiddle) {
                    if (   sz1HasntChangedByMoreThanOne()
                        && sz1HasntShrunk()
                        && sz2HasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof MergeContradictionRule) {
                    if (true) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof MergeConjunctionRule) {
                    if (   sz1HasntChangedByMoreThanOne()
                        && sz2HasntShrunk()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof RemoveNotRule) {
                    if (   sz1HasntChangedByMoreThanOne()
                        && sz2HasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof NotTrueIsFalseRule) {
                    if (sz1HasntShrunk()
                        && sz1HasntChangedByMoreThanOne()
                        && sz2HasntShrunk()
                        && sz2HasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof NotFalseIsTrueRule) {
                    if (   sz1HasntGrown()
                        && sz2HasntGrown()) {
                    } else {
                        showreport("" + r);
                    }
                } else {
                    showreport(" unexpected change : " + r);
                }
            }
        }
        System.out.println("");
        for (int i = 0; i < HRules.size(); i++) {
            Rule r = (Rule) HRules.get(i);
            System.out.println("" + resultsHM.get(r.name) + " " + r.name);
        }
    }
    */
}
