package rwd.rules.inputspec;
import rwd.abstractsyntax.eulerdiagram.Contour;
import rwd.abstractsyntax.eulerdiagram.Zone;
import rwd.abstractsyntax.spiderdiagram.Diagram;
//import rwd.abstractsyntax.spiderdiagram.DiagramFileUser;
import rwd.abstractsyntax.spiderdiagram.FalseDiagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import java.util.Vector;
import java.util.Iterator;

import rwd.abstractsyntax.spiderdiagram.Spider;
import rwd.rules.application.RuleAppliesWithString;

public class RuleAddContour extends RuleNeedsInput {
	private RuleAddContour() {
		super("sd: add contour");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new RuleAddContour();
		}
		return example;
	}
    public boolean isInvertible(){
        return true;
    }
    
	public Class getInputType() {
		try {
			return Class.forName("java.lang.String");
		} catch (ClassNotFoundException x) { /**/
			System.out.println("returning null from RuleAddContour");
			return null;
		}
	}
	public Diagram applyRule(RuleApplicationSpec r) {
		String s = "";
		UnitaryDiagram ud = null;
		try {
			s = ((RuleAppliesWithString) r).s;
			ud = (UnitaryDiagram) (((RuleAppliesWithString) r).d);
            //System.out.println("add "+s+" to diagram "+DiagramFileUser.toSaveString(ud));
		} catch (ClassCastException e) {
            throw new IllegalArgumentException();
		}
		Contour newc = Contour.getContour(s);
        if(ud.getCloneOfContourSet().contains(newc)){
            throw new IllegalArgumentException();
        }
		//System.out.println("adding contour "+newc);
		// get zones of ud
		// make two new zones for each old one
		Vector newZones = new Vector();
		Vector newShadedZones = new Vector();
		Vector newHabitats = new Vector();

		for (int i = 0; i < ud.getSpiders().size(); i++) {
			newHabitats.add(new Vector());
		}

        Iterator zi = ud.getZoneIterator();
        while(zi.hasNext()){
            Zone oldz = (Zone)zi.next();
			//System.out.println("considering old zone ("+oldz.getContainingContours()
			//    +","+oldz.getExcludingContours()+")");
			Vector inContours1 =
				(Vector) (oldz.getContainingContours().clone());
			Vector inContours2 =
				(Vector) (oldz.getContainingContours().clone());
			Vector outContours1 =
				(Vector) (oldz.getExcludingContours().clone());
			Vector outContours2 =
				(Vector) (oldz.getExcludingContours().clone());
			inContours1.add(newc);
			outContours2.add(newc);
			Zone newz1 = Zone.getZone(inContours1, outContours1);
			Zone newz2 = Zone.getZone(inContours2, outContours2);
			newZones.add(newz1);
			newZones.add(newz2);
			if (ud.containsShaded(oldz)) {
				newShadedZones.add(newz1);
				newShadedZones.add(newz2);
			}
			for (int j = 0; j < ud.getSpiders().size(); j++) {
				Spider sp = (Spider) (ud.getSpiders().get(j));
				if (sp.getHabitat().contains(oldz)) {
					Vector newH = (Vector) newHabitats.get(j);
					newH.add(newz1);
					newH.add(newz2);
				}
			}
		}
		UnitaryDiagram newd = new UnitaryDiagram(newZones, "outcome");
		for (int i = 0; i < ud.getSpiders().size(); i++) {
			newd.addSpider((Vector) newHabitats.get(i));
		}
		newd.shadeRegion(newShadedZones);
		//System.out.println("returning new diagram "+DiagramFileUser.toSaveString(newd));
		return newd;
	}
	public boolean canApplyTo(Diagram d) {
			return d instanceof UnitaryDiagram &&
            !(d instanceof FalseDiagram);
	}
}
