package rwd.rules.inputspec;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.FalseDiagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.application.RuleAppliesToDiagramAndDiagram;

public class RuleFalseImpliesAnything extends RuleNeedsInput {
	private RuleFalseImpliesAnything() {
		super("sd: F->Anything");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new RuleFalseImpliesAnything();
		}
		return example;
	}
    public boolean isInvertible(){
        return false;
    }

	public Class getInputType() {
		try {
			return Class.forName("as.Diagram");
		} catch (ClassNotFoundException x) {
			return null;
		}
	}

	public boolean canApplyTo(Diagram d) {
		return d instanceof FalseDiagram;
	}

	public Diagram applyRule(RuleApplicationSpec r) {
		Diagram other = null;
		try {
			other = ((RuleAppliesToDiagramAndDiagram) r).other;
		} catch (ClassCastException e) {
		}
		return other;
	}
}
