package rwd.rules.inputspec;
import rwd.abstractsyntax.spiderdiagram.AndCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.Diagram;
//import rwd.abstractsyntax.spiderdiagram.DiagramFileUser;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.application.RuleAppliesToDiagramAndDiagram;
import rwd.abstractsyntax.spiderdiagram.OrCompoundDiagram;
import java.util.Vector;

public class RuleReverseOrAbsorbtion extends RuleNeedsInput {
	private RuleReverseOrAbsorbtion() {
		super("sd: P->P and (P or Q)");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new RuleReverseOrAbsorbtion();
		}
		return example;
	}
    public boolean isInvertible(){
        return false;
    }    

	public Class getInputType() {
		try {
			return Class.forName("rwd.abstractsyntax.spiderdiagram.Diagram");
		} catch (ClassNotFoundException x) {
			System.out.println("Diagram class not found for RulePToPOrRubbish");
			return null;
		}
	}
	public boolean canApplyTo(Diagram d) {
		return true;
	}

	public Diagram applyRule(RuleApplicationSpec r) {
		Diagram other = null;
		try {
			other = ((RuleAppliesToDiagramAndDiagram) r).other;
		} catch (ClassCastException e) {
			System.out.println("spec wasn't right in RulePToPOrRubbish");
			return null;
		}
		Vector diagrams = new Vector();
		diagrams.add(r.d.getClone());
		diagrams.add(other.getClone());
        Diagram result = new AndCompoundDiagram(diagrams, "PandQ");
        Vector diagrams2 = new Vector();
        diagrams2.add(r.d.getClone());
        diagrams2.add(result);
        return new OrCompoundDiagram(diagrams2,"Por(PandQ)");
	}
}
