package rwd.rules.nospec;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.NotCompoundDiagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleAppliesToJustADiagram;
import rwd.rules.application.RuleApplicationSpec;

public class RemoveNotNotRule extends RuleNoSpec {
	private RemoveNotNotRule() {
		super("sd: Not(Not(P)) is P");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new RemoveNotNotRule();
		}
		return example;
	}
    public boolean isInvertible(){
        return true;
    }

	public boolean canApplyTo(Diagram d) {
        if(!(d instanceof NotCompoundDiagram)){
            return false;
        } else {
            Diagram child = (Diagram)(((NotCompoundDiagram)d).getChildren().get(0));
            if(!(child instanceof NotCompoundDiagram)){
                return false;
            } else{
                return true;
            }            
        }
	}
	public Diagram applyRule(RuleApplicationSpec r) {
		RuleAppliesToJustADiagram rajd = (RuleAppliesToJustADiagram) r;
		Diagram d = rajd.d;
        Diagram child = (Diagram)(((NotCompoundDiagram)d).getChildren().get(0));
        Diagram grandchild = (Diagram)(((NotCompoundDiagram)child).getChildren().get(0));
		return grandchild.getClone();
	}
}
