package rwd.rules.nospec;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.DiagramFileUser;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.application.RuleAppliesToJustADiagram;
import rwd.rules.choicespec.RuleWithChoice;
import rwd.rules.choicespec.RuleDistributeAndOverOr;

public class ToDNFRule extends RuleNoSpec {
	public ToDNFRule() {
		super("sd: to disjunctive normal form");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new ToDNFRule();
		}
		return example;
	}
    public boolean isInvertible(){
        return true;        
    }

	public boolean canApplyTo(Diagram d) {
		return true;
	}

	public Diagram applyRule(RuleApplicationSpec r) {
		RuleAppliesToJustADiagram rajd = (RuleAppliesToJustADiagram) r;
		Diagram d = rajd.d;
        Diagram startd = d;

		RuleWithChoice rwc = (RuleWithChoice)RuleDistributeAndOverOr.getRule();
        int numApps = 0;
		partLoop : while (true) {
            //System.out.println("seek an application of DistributeAndOverOr");
            RuleApplicationSpec spec = rwc.findApplicableSpecForPart(d);
            if (spec == null) {
                break partLoop;
            }
            //System.out.println("spec is " + spec);
            //System.out.println("apply DistributeAndOverOr");
            d = rwc.applyRuleToPart(d, spec);
            numApps++;
            if(numApps>1000){
                DiagramFileUser.saveToFile(startd);
                System.exit(0);
            }
		}
		return d;
	}    
}
