package rwd.tableaux.diagram;

import java.util.List;
import java.util.Set;

import rwd.abstractsyntax.eulerdiagram.Contour;
import rwd.abstractsyntax.eulerdiagram.Zone;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;

/**
 * @author Octavian Patrascoiu
 *
 */
public interface Equaliser {
	public Diagram equaliseDiagram(Diagram d);
	public Diagram equaliseContours(Diagram d);
	public Diagram equaliseZones(Diagram d);

	public List equaliseDiagrams(List diags);
	public List equaliseContours(List diags);
	public List equaliseZones(List diags);

	public void computeContours(Diagram d, Set contours);
	public void computeZones(Diagram d, Set zones);
	
	public UnitaryDiagram addContour(UnitaryDiagram ud, Contour c);
	public UnitaryDiagram addContours(UnitaryDiagram ud, List cs);
	public UnitaryDiagram addZone(UnitaryDiagram ud, Zone z);
}
