package rwd.views.abstracttoconcrete.converting;
import rwd.views.graph.*;
import rwd.abstractsyntax.eulerdiagram.Contour;
import rwd.abstractsyntax.eulerdiagram.Zone;
import rwd.concretesyntax.ConcreteDiagram;
import rwd.concretesyntax.eulerdiagram.*;
import java.util.Vector;
import java.util.TreeSet;
import java.util.Iterator;
import java.awt.Polygon;
import java.awt.Rectangle;

public class Dualiser {

	private static Graph dualise(
		Graph circularised,
		Vector parents) { //System.out.println(" circularised "+circularised);
		Vector faceCycles = FaceCycle.faceCycles(circularised);
		// find out which faceCycle is outside
		//System.out.println("faceCycles are "+faceCycles);
		FaceCycle outside = null;
		Vector insideFaceCycles = new Vector();

		Iterator faceCycIt = faceCycles.iterator();
		while (faceCycIt.hasNext()) {
			FaceCycle faceCyc = (FaceCycle) (faceCycIt.next());
			//System.out.print("is "+faceCyc+" outside?");
			boolean b = faceCyc.containsInsideAll(circularised.nodes());
			if (b) {
				outside = faceCyc;
				//System.out.println("yes");
			} else {
				insideFaceCycles.add(faceCyc);
				//System.out.println("no");
			}
		}
		Graph result = new Graph();
		// add inside arcs using inside faces
		//System.out.println("add inside arcs");
		Iterator i = insideFaceCycles.iterator();
		while (i.hasNext()) {
			FaceCycle fc = (FaceCycle) (i.next());
			//System.out.println("got an inside faceCycle:"+fc);
			Vector dEdges = fc.directedEdges;
			while (dEdges.size() > 0) {
				Iterator ie = dEdges.iterator();
				DirectedEdge de = (DirectedEdge) (ie.next());
				//System.out.println("directedEdge inside is "+de);
				//System.out.println("from "+de.from()+" to "+de.to());
				Comparable c = de.label();
				secondEdgeLoop : while (ie.hasNext()) {
					DirectedEdge de2 = (DirectedEdge) (ie.next());
					if (de2.label().compareTo(c) == 0) {
						//System.out.println("matching directedEdge is "+de2);
						Node n = de.midNode("" + de.edge().hashCode());
						Node n2 = de2.midNode("" + de2.edge().hashCode());
						//System.out.println("build from "+n+" to "+n2);
						Edge e = Edge.getEdge(n, n2);
						e.setLabel(c);
						//System.out.println("built edge labelled "+c);
						result.add(n);
						result.add(n2);
						result.add(e);
						dEdges.remove(de2);
						dEdges.remove(de);
						break secondEdgeLoop;
					}
				}
			}
		}
		// now use the outsideFace
		//System.out.println("outside is "+outside);
		// reverse the outside cycle
		outside = outside.reverseFaceCycle();
		// rearrange the Vector of DirectedEdges to start at null
		Vector directedEdges = outside.directedEdges;
		i = directedEdges.iterator();
		DirectedEdge first = null;
		int shiftRound = -1;
		edgeLoop : while (i.hasNext()) {
			DirectedEdge de = (DirectedEdge) (i.next());
			shiftRound++;
			if (first == null
				|| first.from().label1().containsAll(de.from().label1())) {
				first = de;
				break edgeLoop;
			}
		}
		Vector startsAtNull = new Vector();
		//startsAtNull.add(first);
		i = directedEdges.iterator();
		while (i.hasNext()) {
			DirectedEdge de = (DirectedEdge) (i.next());
			startsAtNull.add(de);
		}
		i = directedEdges.iterator();
		boolean foundFirst = false;
		edgeLoop : while (!foundFirst) {
			DirectedEdge de = (DirectedEdge) (i.next());
			if (de != first) {
				startsAtNull.add(de);
			} else {
				foundFirst = true;
				break edgeLoop;
			}
		}
		// look for adjacent pairs of equal edge-labels
		//System.out.println("cycled to "+startsAtNull);
		double stepSize =
			Math.max(
				1 - Math.cos(Math.PI * 2 / circularised.nodes().size()),
				0.2);
		//System.out.println("stepSize is "+stepSize);
		double stepOut = stepSize;
		DirectedEdge firstDE = null;
		Comparable firstC = null;
		while (startsAtNull.size() > 0) {
			Iterator ide = startsAtNull.iterator();
			Vector toBeRemoved = new Vector();
			DirectedEdge nextDE = null;
			Comparable nextC = null;
			//System.out.println("startAtNull is "+startsAtNull);
			while (ide.hasNext()) {
				nextDE = (DirectedEdge) (ide.next());
				nextC = nextDE.label();
				//System.out.println("compare "+firstDE+" and "+nextDE);
				if (firstC != null
					&& nextC.compareTo(firstC) == 0) { // found a matching pair
					//System.out.println("found match "+firstDE+" and "+nextDE);
					toBeRemoved.add(firstDE);
					toBeRemoved.add(nextDE);
					Node midNode =
						firstDE.midNode("" + firstDE.edge().hashCode());
					Comparable c =
						"stepOut "
							+ stepOut
							+ " "
							+ midNode.label1().iterator().next();
					TreeSet label = new TreeSet();
					label.add(c);
					// find firstDE and nextDE in outside
					//System.out.println("firstDE is "+firstDE);
					//System.out.println("nextDE is "+nextDE);
					int startIndex =
						outside.directedEdges.indexOf(firstDE) + shiftRound;
					int stopIndex =
						outside.directedEdges.indexOf(nextDE) + shiftRound;
					Vector nodeSequence = new Vector();
					//System.out.println("start at "+startIndex+" stop at "+stopIndex);
					//System.out.println("shiftRound is "+shiftRound); ///always zero?????
					//System.out.println("outside is "+outside);
					for (int index = startIndex; index <= stopIndex; index++) {
						double step = 0.0;
						boolean isNextToInsert = false;
						//////////////////////////////////////////////////////////////////
						if (index == startIndex) {
							// a reduction in stepOut to smooth off curves
							// depends upon whether there's an inserted diagram
							// after startIndex ie. end if firstDE
							// or before stopIndex ie start of nextDE
							Node endOfFirstDE = firstDE.to();
							//System.out.println("end of firstDE is "+endOfFirstDE);
							//System.out.println("parents are "+parents);
							// first check that this node is the first with this label
							// use Node set iterator not outside iterator
							Iterator nodeIt = circularised.nodes().iterator();
							boolean wasFirst = true;
							checkIsFirst : while (nodeIt.hasNext()) {
								Node n = (Node) (nodeIt.next());
								if (n != endOfFirstDE) {
									if (n
										.label1()
										.equals(endOfFirstDE.label1())) {
										wasFirst = false;
										break checkIsFirst;
									}
								} else {
									break checkIsFirst;
								}
							}
							//if(wasFirst)
							//{ //System.out.println("first occurence of "+endOfFirstDE.label()
							//                                            +" is at "+index);}
							// then check that this label occurs as a parent
							isNextToInsert = false;
							Iterator thisIt = parents.iterator();
							while (thisIt.hasNext()) {
								Zone parent = (Zone) (thisIt.next());
								if (parent
									.getContainingContours()
									.equals(endOfFirstDE.label1())) {
									isNextToInsert = true;
								}
							}
							if (wasFirst && isNextToInsert) {
								step = stepOut;
							} else if (stopIndex == startIndex + 1) {
								step = 0.0;
							} // !!!! use midNodes instead of stepOut nodes
							else {
								step = stepOut - 2 * stepSize / 3;
							}
						}
						////////////////////////////////////////////////////////////////
						else if (index == stopIndex) {
							Node startOfNextDE = nextDE.from();
							//System.out.println("start of nextDE is "+startOfNextDE);
							//System.out.println("parents are "+parents);
							// first check that this node is the first with this label
							// use Node set iterator not outside iterator
							Iterator nodeIt = circularised.nodes().iterator();
							boolean wasFirst = true;
							checkIsFirst : while (nodeIt.hasNext()) {
								Node n = (Node) (nodeIt.next());
								if (n != startOfNextDE) {
									if (n
										.label1()
										.equals(startOfNextDE.label1())) {
										wasFirst = false;
										break checkIsFirst;
									}
								} else {
									break checkIsFirst;
								}
							}
							// then check that this label occurs as a parent
							isNextToInsert = false;
							Iterator thisIt = parents.iterator();
							while (thisIt.hasNext()) {
								Zone parent = (Zone) (thisIt.next());
								if (parent
									.getContainingContours()
									.equals(startOfNextDE.label1())) {
									isNextToInsert = true;
								}
							}
							if (wasFirst
								&& isNextToInsert) { //System.out.println("OK - make more space here at stop "+stopIndex);
								step = stepOut;
							} else if (
								stopIndex == startIndex + 1) {
								//System.out.println("stop is just after start");
								step = 0.0;
							} else {
								step = stepOut - 2 * stepSize / 3;
							}
						} else {
							step = stepOut;
						}
						//System.out.println("step at "+index+" is "+step);
						Position p = getPosition(index, step);
						label = new TreeSet();
						label.add("" + step + " " + index);
						// don't add in if step = 0.0
						Node addN = Node.getNode(label,new TreeSet());
						addN.setPosition(p);
						/*10May            if(previousNode!=null
						              && (stopIndex == startIndex + 1 && isNextToInsert))
						            { //System.out.println("making intermediate position");
						              p = getPositionJustBefore(index,stepOut*1.8);
						              label = new TreeSet();
						              label.add("before "+stepOut+" "+index);
						              Node intermediateNode = Node.getNode(label);
						              intermediateNode.setPosition(p);
						              //if(step!=0.0) // new code at Canterbury
						              { nodeSequence.add(intermediateNode); }
						            }
						/*/ //10May
						//10May            else if(previousNode!=null
						//10May              && (stopIndex > startIndex + 1)
						//10May              && stepOut > 0  // new line in canterbury
						//10May              )
						//if(previousNode!=null)
						/*10May            { // build an intermediate node between previousNode and addN
						              //System.out.println("step just before "+index+" is "+stepOut);
						              p = getPositionJustBefore(index,stepOut);
						              label = new TreeSet();
						              label.add("before "+stepOut+" "+index);
						              Node intermediateNode = Node.getNode(label);
						              intermediateNode.setPosition(p);
						              //if(step!=0.0) // new code at Canterbury
						              { nodeSequence.add(intermediateNode); }
						
						            }
						*/ //10May
						//if(step!=0.0) // new code at Canterbury
						{
							nodeSequence.add(addN);
						}
						//System.out.println(""+index+"node sequence is "+nodeSequence);
					}
					//System.out.println("");
					//System.out.println("from "+firstDE+" to "+nextDE);
					//System.out.println("nodeSequence is "+nodeSequence);
					// I have nodeSequence, now create edges in turn and add to result
					Iterator addNIt = nodeSequence.iterator();
					Node addN = (Node) (addNIt.next());
					Edge e =
						Edge.getEdge(
							firstDE.midNode("" + firstDE.edge().hashCode()),
							addN);
					e.setLabel(firstDE.label());
					//System.out.println("just built edge labelled "+e.label());
					result.add(e);
					result.add(addN);
					Node lastN = addN;
					while (addNIt.hasNext()) {
						addN = (Node) (addNIt.next());
						//System.out.println(" build between "+lastN +" and "+addN);
						e = Edge.getEdge(lastN, addN);
						e.setLabel(firstDE.label());
						result.add(e);
						result.add(addN);
						lastN = addN;
					}
					e =
						Edge.getEdge(
							lastN,
							nextDE.midNode("" + nextDE.edge().hashCode()));
					e.setLabel(firstDE.label());
					result.add(e);
					firstDE = null;
				} else {
					firstC = nextC;
					firstDE = nextDE;
				}
				//System.out.println("about to leave loop code: first="+firstDE);
			}
			//System.out.println("toBeRemoved is size "+toBeRemoved.size());
			startsAtNull.removeAll(toBeRemoved);
			//System.out.println("startsAtNull is size "+startsAtNull.size());
			//System.out.println("incrementing stepOut");
			stepOut = stepOut + stepSize;
			firstDE = null;
			firstC = null;
		}
		return result;
	}
	private static Graph dualiseNew(
		Graph circularised,
		Vector parents) { //System.out.println(" circularised "+circularised);
		Vector faceCycles = FaceCycle.faceCycles(circularised);
		// find out which faceCycle is outside
		//System.out.println("faceCycles are "+faceCycles);
		FaceCycle outside = null;
		Vector insideFaceCycles = new Vector();

		Iterator faceCycIt = faceCycles.iterator();
		while (faceCycIt.hasNext()) {
			FaceCycle faceCyc = (FaceCycle) (faceCycIt.next());
			//System.out.print("is "+faceCyc+" outside?");
			boolean b = faceCyc.containsInsideAll(circularised.nodes());
			if (b) {
				outside = faceCyc;
				//System.out.println("yes");
			} else {
				insideFaceCycles.add(faceCyc);
				//System.out.println("no");
			}
		}
		Graph result = new Graph();
		// add inside arcs using inside faces
		//System.out.println("add inside arcs");
		Iterator i = insideFaceCycles.iterator();
		while (i.hasNext()) {
			FaceCycle fc = (FaceCycle) (i.next());
			//System.out.println("got an inside faceCycle:"+fc);
			Vector dEdges = fc.directedEdges;
			while (dEdges.size() > 0) {
				Iterator ie = dEdges.iterator();
				DirectedEdge de = (DirectedEdge) (ie.next());
				//System.out.println("directedEdge inside is "+de);
				//System.out.println("from "+de.from()+" to "+de.to());
				Comparable c = de.label();
				secondEdgeLoop : while (ie.hasNext()) {
					DirectedEdge de2 = (DirectedEdge) (ie.next());
					if (de2.label().compareTo(c) == 0) {
						//System.out.println("matching directedEdge is "+de2);
						Node n = de.midNode("" + de.edge().hashCode());
						Node n2 = de2.midNode("" + de2.edge().hashCode());
						//System.out.println("build from "+n+" to "+n2);
						Edge e = Edge.getEdge(n, n2);
						e.setLabel(c);
						//System.out.println("built edge labelled "+c);
						result.add(n);
						result.add(n2);
						result.add(e);
						dEdges.remove(de2);
						dEdges.remove(de);
						break secondEdgeLoop;
					}
				}
			}
		}
		// now use the outsideFace
		//System.out.println("outside is "+outside);
		// reverse the outside cycle
		outside = outside.reverseFaceCycle();
		// rearrange the Vector of DirectedEdges to start at null
		Vector directedEdges = outside.directedEdges;
		i = directedEdges.iterator();
		DirectedEdge first = null;
		int shiftRound = -1;
		edgeLoop : while (i.hasNext()) {
			DirectedEdge de = (DirectedEdge) (i.next());
			shiftRound++;
			if (first == null
				|| first.from().label1().containsAll(de.from().label1())) {
				first = de;
				break edgeLoop;
			}
		}
		Vector startsAtNull = new Vector();
		//startsAtNull.add(first);
		i = directedEdges.iterator();
		while (i.hasNext()) {
			DirectedEdge de = (DirectedEdge) (i.next());
			startsAtNull.add(de);
		}
		i = directedEdges.iterator();
		boolean foundFirst = false;
		edgeLoop : while (!foundFirst) {
			DirectedEdge de = (DirectedEdge) (i.next());
			if (de != first) {
				startsAtNull.add(de);
			} else {
				foundFirst = true;
				break edgeLoop;
			}
		}
		// look for adjacent pairs of equal edge-labels
		//System.out.println("cycled to "+startsAtNull);
		double stepSize =
			Math.max(
				1 - Math.cos(Math.PI * 2 / circularised.nodes().size()),
				0.2);
		//System.out.println("stepSize is "+stepSize);
		double stepOut = stepSize;
		DirectedEdge firstDE = null;
		Comparable firstC = null;
		while (startsAtNull.size() > 0) {
			Iterator ide = startsAtNull.iterator();
			Vector toBeRemoved = new Vector();
			DirectedEdge nextDE = null;
			Comparable nextC = null;
			//System.out.println("startAtNull is "+startsAtNull);
			while (ide.hasNext()) {
				nextDE = (DirectedEdge) (ide.next());
				nextC = nextDE.label();
				//System.out.println("compare "+firstDE+" and "+nextDE);
				if (firstC != null
					&& nextC.compareTo(firstC) == 0) { // found a matching pair
					//System.out.println("found match "+firstDE+" and "+nextDE);
					toBeRemoved.add(firstDE);
					toBeRemoved.add(nextDE);
					Node midNode =
						firstDE.midNode("" + firstDE.edge().hashCode());
					Comparable c =
						"stepOut "
							+ stepOut
							+ " "
							+ midNode.label1().iterator().next();
					TreeSet label = new TreeSet();
					label.add(c);
					// find firstDE and nextDE in outside
					//System.out.println("firstDE is "+firstDE);
					//System.out.println("nextDE is "+nextDE);
					int startIndex =
						outside.directedEdges.indexOf(firstDE) + shiftRound;
					int stopIndex =
						outside.directedEdges.indexOf(nextDE) + shiftRound;
					Vector nodeSequence = new Vector();
					//System.out.println("start at "+startIndex+" stop at "+stopIndex);
					//System.out.println("shiftRound is "+shiftRound); ///always zero?????
					//System.out.println("outside is "+outside);
					for (int index = startIndex; index <= stopIndex; index++) {
						double step = 0.0;
						boolean isNextToInsert = false;
						//////////////////////////////////////////////////////////////////
						if (index == startIndex) {
							// a reduction in stepOut to smooth off curves
							// depends upon whether there's an inserted diagram
							// after startIndex ie. end if firstDE
							// or before stopIndex ie start of nextDE
							Node endOfFirstDE = firstDE.to();
							//System.out.println("end of firstDE is "+endOfFirstDE);
							//System.out.println("parents are "+parents);
							// first check that this node is the first with this label
							// use Node set iterator not outside iterator
							Iterator nodeIt = circularised.nodes().iterator();
							boolean wasFirst = true;
							checkIsFirst : while (nodeIt.hasNext()) {
								Node n = (Node) (nodeIt.next());
								if (n != endOfFirstDE) {
									if (n
										.label1()
										.equals(endOfFirstDE.label1())) {
										wasFirst = false;
										break checkIsFirst;
									}
								} else {
									break checkIsFirst;
								}
							}
							//if(wasFirst)
							//{ //System.out.println("first occurence of "+endOfFirstDE.label()
							//                                            +" is at "+index);}
							// then check that this label occurs as a parent
							isNextToInsert = false;
							Iterator thisIt = parents.iterator();
							while (thisIt.hasNext()) {
								Zone parent = (Zone) (thisIt.next());
								if (parent
									.getContainingContours()
									.equals(endOfFirstDE.label1())) {
									isNextToInsert = true;
								}
							}
							if (wasFirst && isNextToInsert) {
								step = stepOut;
							} else if (stopIndex == startIndex + 1) {
								step = 0.0;
							} // !!!! use midNodes instead of stepOut nodes
							else {
								step = stepOut - 2 * stepSize / 3;
							}
						}
						////////////////////////////////////////////////////////////////
						else if (index == stopIndex) {
							Node startOfNextDE = nextDE.from();
							//System.out.println("start of nextDE is "+startOfNextDE);
							//System.out.println("parents are "+parents);
							// first check that this node is the first with this label
							// use Node set iterator not outside iterator
							Iterator nodeIt = circularised.nodes().iterator();
							boolean wasFirst = true;
							checkIsFirst : while (nodeIt.hasNext()) {
								Node n = (Node) (nodeIt.next());
								if (n != startOfNextDE) {
									if (n
										.label1()
										.equals(startOfNextDE.label1())) {
										wasFirst = false;
										break checkIsFirst;
									}
								} else {
									break checkIsFirst;
								}
							}
							// then check that this label occurs as a parent
							isNextToInsert = false;
							Iterator thisIt = parents.iterator();
							while (thisIt.hasNext()) {
								Zone parent = (Zone) (thisIt.next());
								if (parent
									.getContainingContours()
									.equals(startOfNextDE.label1())) {
									isNextToInsert = true;
								}
							}
							if (wasFirst
								&& isNextToInsert) { //System.out.println("OK - make more space here at stop "+stopIndex);
								step = stepOut;
							} else if (
								stopIndex == startIndex + 1) {
								//System.out.println("stop is just after start");
								step = 0.0;
							} else {
								step = stepOut - 2 * stepSize / 3;
							}
						} else {
							step = stepOut;
						}
						//System.out.println("step at "+index+" is "+step);
						Position p = getPosition(index, step);
						label = new TreeSet();
						label.add("" + step + " " + index);
						// don't add in if step = 0.0
						Node addN = Node.getNode(label, new TreeSet());
						addN.setPosition(p);
						/*10May            if(previousNode!=null
						              && (stopIndex == startIndex + 1 && isNextToInsert))
						            { //System.out.println("making intermediate position");
						              p = getPositionJustBefore(index,stepOut*1.8);
						              label = new TreeSet();
						              label.add("before "+stepOut+" "+index);
						              Node intermediateNode = Node.getNode(label);
						              intermediateNode.setPosition(p);
						              //if(step!=0.0) // new code at Canterbury
						              { nodeSequence.add(intermediateNode); }
						            }
						/*/ //10May
						//10May            else if(previousNode!=null
						//10May              && (stopIndex > startIndex + 1)
						//10May              && stepOut > 0  // new line in canterbury
						//10May              )
						//if(previousNode!=null)
						/*10May            { // build an intermediate node between previousNode and addN
						              //System.out.println("step just before "+index+" is "+stepOut);
						              p = getPositionJustBefore(index,stepOut);
						              label = new TreeSet();
						              label.add("before "+stepOut+" "+index);
						              Node intermediateNode = Node.getNode(label);
						              intermediateNode.setPosition(p);
						              //if(step!=0.0) // new code at Canterbury
						              { nodeSequence.add(intermediateNode); }
						
						            }
						*/ //10May
						//if(step!=0.0) // new code at Canterbury
						{
							nodeSequence.add(addN);
						}
						//System.out.println(""+index+"node sequence is "+nodeSequence);
					}
					//System.out.println("");
					//System.out.println("from "+firstDE+" to "+nextDE);
					//System.out.println("nodeSequence is "+nodeSequence);
					// I have nodeSequence, now create edges in turn and add to result
					Iterator addNIt = nodeSequence.iterator();
					Node addN = (Node) (addNIt.next());
					Edge e =
						Edge.getEdge(
							firstDE.midNode("" + firstDE.edge().hashCode()),
							addN);
					e.setLabel(firstDE.label());
					//System.out.println("just built edge labelled "+e.label());
					result.add(e);
					result.add(addN);
					Node lastN = addN;
					while (addNIt.hasNext()) {
						addN = (Node) (addNIt.next());
						//System.out.println(" build between "+lastN +" and "+addN);
						e = Edge.getEdge(lastN, addN);
						e.setLabel(firstDE.label());
						result.add(e);
						result.add(addN);
						lastN = addN;
					}
					e =
						Edge.getEdge(
							lastN,
							nextDE.midNode("" + nextDE.edge().hashCode()));
					e.setLabel(firstDE.label());
					result.add(e);
					firstDE = null;
				} else {
					firstC = nextC;
					firstDE = nextDE;
				}
				//System.out.println("about to leave loop code: first="+firstDE);
			}
			//System.out.println("toBeRemoved is size "+toBeRemoved.size());
			startsAtNull.removeAll(toBeRemoved);
			//System.out.println("startsAtNull is size "+startsAtNull.size());
			//System.out.println("incrementing stepOut");
			stepOut = stepOut + stepSize;
			firstDE = null;
			firstC = null;
		}
		return result;
	}

/*	public static AEDView makePolygons(
		Graph oldg,
		Vector parents,
		String described) { //System.out.println("g is "+g);
		if (oldg.nodes().size() <= 2) {
			return new AEDView(described, new TreeSet());
		}
		TreeSet zones = makeZonesFor(oldg.nodes());
		//System.out.println("zones of oldg are "+zones);
		//System.out.println("calling circularise from dualiser");
		Graph circularised = Circulariser.circularise(oldg, parents);
		//System.out.println("returned from circulariser");
		// assumes that g is made up of polygonal parts
		Graph g = dualise(circularised, parents);
		// g is now a completely different rwd.views.graph: its nodes have String labels
		// its nodes are labelled mid+hashCode(edge)+position
		// or pairs of numbers [2 3]+position which say stepsOut, angleround
		AEDView result = new AEDView(described, zones);

		TreeSet edgesCopy = (TreeSet) (g.edges().clone());
		//System.out.println("");
		//System.out.println("edgesCopy has "+edgesCopy.size()+" elements");
		while (edgesCopy.size() > 0) {
			Edge e = (Edge) (edgesCopy.iterator().next());
			//System.out.println("start edge e is "+e);
			edgesCopy.remove(e);
			//System.out.println("edgesCopy.size() is "+edgesCopy.size());
			Vector xsArray = new Vector();
			Vector ysArray = new Vector();
			Iterator i = e.ends().iterator();
			Node n = (Node) (i.next());
			//System.out.println("add "+n);
			double addIntX = n.getPosition().getX();
			double addIntY = n.getPosition().getY();
			xsArray.add(new Double(n.getPosition().getX()));
			ysArray.add(new Double(n.getPosition().getY()));
			//System.out.println("array for xcoords is "+xsArray);
			//System.out.println("array for ycoords is "+ysArray);
			Node firstN = n;
			n = (Node) (i.next());
			//System.out.println("add "+n);
			double newAddIntX = n.getPosition().getX();
			double newAddIntY = n.getPosition().getY();
			//System.out.println("is "+newAddIntX+"!="+addIntX+" || "+newAddIntY+"!="+addIntY+"?");
			if (newAddIntX != addIntX
				|| newAddIntY != addIntY) { //System.out.println("yes");
				xsArray.add(new Double(newAddIntX));
				ysArray.add(new Double(newAddIntY));
				addIntX = newAddIntX;
				addIntY = newAddIntY;
			}
			//System.out.println("array for xcoords is "+xsArray);
			//System.out.println("array for ycoords is "+ysArray);
			boolean haveCompleted = false;
			while (!haveCompleted) { // seek edge between n and next place
				//System.out.println("we have "+edgesCopy.size()+" edges");
				Iterator edgeIt = edgesCopy.iterator();
				edgeSearch : while (edgeIt.hasNext()) {
					e = (Edge) (edgeIt.next());
					//System.out.println("see if "+e+" meets "+n);
					if (e.ends().contains(n)) {
						// decide whether the other end is firstN
						//System.out.println("consider edge "+e);
						if (e.ends().contains(firstN)) {
							haveCompleted = true;
						} else {
							Iterator iends = e.ends().iterator();
							Node nhere = (Node) (iends.next());
							//System.out.print("add "+nhere+"?");
							if (nhere.equals(n)) {
								nhere = (Node) (iends.next());
								//System.out.println("no : add"+nhere);
							}
							//else{ //System.out.println("yes"); }
							newAddIntX = nhere.getPosition().getX();
							newAddIntY = nhere.getPosition().getY();
							if (newAddIntX != addIntX
								|| newAddIntY != addIntY) {
								xsArray.add(new Double(newAddIntX));
								ysArray.add(new Double(newAddIntY));
								addIntX = newAddIntX;
								addIntY = newAddIntY;
							}
							//System.out.println("array for xcoords is "+xsArray);
							//System.out.println("array for ycoords is "+ysArray);
							n = nhere;
						}
						edgesCopy.remove(e);
						break edgeSearch;
					}
				}
			}
			if (xsArray.get(0).equals(xsArray.get(xsArray.size() - 1))
				&& ysArray.get(0).equals(
					ysArray.get(
						ysArray.size() - 1))) {
				//System.out.println("first equals last");
				xsArray.remove(0);
				ysArray.remove(0);
			}
			//System.out.println("Array for xcoords is "+xsArray);
			//System.out.println("Array for ycoords is "+ysArray);
			//System.out.println("has completed? "+haveCompleted);
			int[] xs = new int[xsArray.size()];
			int[] ys = new int[ysArray.size()];
			i = xsArray.iterator();
			Iterator j = ysArray.iterator();
			int index = 0;
			while (i.hasNext()) {
				xs[index] = (int) ((Double) (i.next())).doubleValue();
				ys[index] = (int) ((Double) (j.next())).doubleValue();
				index++;
			}
			Polygon p = new Polygon(xs, ys, xsArray.size());
			//System.out.println("dualiser adds "+p);
			//System.out.println("!!!!!!!!!adding contour labelled "+ e.label());
			result.add(p, (Contour) (e.label()));
		}
		// I have an Vector of zones, parents, and a rwd.views.graph with nodes labelled
		// with Strings. At least I have to count and put right number of holes
		// At best I locate those holes using coords of points
		int posnCounter = 0; // only used for rubbish implementation
		Vector parentsCopy = (Vector) (parents.clone());
		// remove from parenstCopy those zones which aren't here yet
		Vector tmp = new Vector();
		Zone smallestZone = null;
		Iterator pIt = parentsCopy.iterator();
		while (pIt.hasNext()) {
			Zone z = (Zone) (pIt.next());
			Vector resultZones = result.zones();
			boolean zoneIsHere = false;
			Iterator rzi = resultZones.iterator();
			resultZoneSearch : while (rzi.hasNext()) {
				if ((Zone) (rzi.next())==z) {
					zoneIsHere = true;
					break resultZoneSearch;
				}
			}
			if (zoneIsHere) {
				tmp.add(z);
				if (smallestZone == null
					|| smallestZone.getContainingContours().containsAll(z.getContainingContours())) {
					smallestZone = z;
				}
			}
		}
		//tmp.remove(smallestZone);
		parentsCopy = tmp;
		//System.out.println("parentsCopy is "+parentsCopy);
		///////////////////////////////////////////////////////////
		while (parentsCopy.size() > 0) {
			pIt = parentsCopy.iterator();
			Zone z = (Zone) (pIt.next());
			// before inserting a rectangle check
			// that z isn't the smallest zone of block
			parentsCopy.remove(z);
			int numOccs = 1;
			Vector toBeRemoved = new Vector();
			Iterator pIt2 = parentsCopy.iterator();
			while (pIt2.hasNext()) {
				Zone z2 = (Zone) (pIt2.next());
				if (z2==z) {
					numOccs++;
					toBeRemoved.add(z2);
				}
			}
			parentsCopy.removeAll(toBeRemoved);
			// I know that zone z needs numOccs holes.
			//System.out.println("parents are "+parents);
			//System.out.println("and I want to add "+numOccs
			//                               +" hole(s) for zone "+z+" in "+result);
			// find node for zone z in circularised
			int centrex = 0, centrey = 0, radius;
			Iterator cni = circularised.nodes().iterator();
			placeSearch : while (cni.hasNext()) {
				Node n = (Node) (cni.next());
				if (n.label1().equals(z.getContainingContours())) {
					//System.out.println("found somewhere to put rectangle");
					centrex = (int) (n.getPosition().getX() * 1.1);
					centrey = (int) (n.getPosition().getY() * 1.1);
					break placeSearch;
				}
			}
			//System.out.println("circle centre is at "+centrex+","+centrey);
			int numCirclePts = circularised.nodes().size();
			TreeSet tmpt = new TreeSet();
			tmpt.addAll(parentsCopy);
			int numStretched = tmpt.size();
			double alpha = 2 * Math.PI / (numCirclePts + 2 * numStretched);
			radius =
				(int) ((result.getBoundingBox().width)
					* (1 - Math.cos(alpha))
					* 0.6);
			//System.out.println("radius is "+radius);
			//System.out.println("centre at "+centrex+" ,"+centrey);
			for (int holeCounter = 0; holeCounter < numOccs; holeCounter++) {
				int lowx =
					centrex - radius / 2 + holeCounter * (radius / numOccs);
				int lowy = centrey - radius / (2 * numOccs);
				//System.out.println("fitting "+holeCounter+"th square");
				//System.out.println("corner at "+lowx+", "+lowy);
				//System.out.println("radius "+radius/numOccs);
				result.add(
					new Rectangle(
						lowx,
						lowy,
						radius / numOccs,
						radius / numOccs),
					z);
			}
			//System.out.println("after adding rectangle result is now "+result);
			posnCounter++;
		}
		return result;
	}*/

	public static AEDView makePolygonsNew(
		Graph oldg,
		Vector parents,
		String described) { //System.out.println("g is "+g);
		if (oldg.nodes().size() <= 2) {
			return new AEDView(described, new TreeSet());
		}
		TreeSet zones = makeZonesFor(oldg.nodes());
		//System.out.println("zones of oldg are "+zones);
		//System.out.println("calling circularise from dualiser");
		Graph circularised = Circulariser.circularise(oldg, parents);
		//System.out.println("returned from circulariser");
		// assumes that g is made up of polygonal parts
		Graph g = dualiseNew(circularised, parents);
		// g is now a completely different rwd.views.graph: its nodes have String labels
		// its nodes are labelled mid+hashCode(edge)+position
		// or pairs of numbers [2 3]+position which say stepsOut, angleround
		AEDView result = new AEDView(described, zones);

		TreeSet edgesCopy = (TreeSet) (g.edges().clone());
		//System.out.println("");
		//System.out.println("edgesCopy has "+edgesCopy.size()+" elements");
		while (edgesCopy.size() > 0) {
			Edge e = (Edge) (edgesCopy.iterator().next());
			//System.out.println("start edge e is "+e);
			edgesCopy.remove(e);
			//System.out.println("edgesCopy.size() is "+edgesCopy.size());
			Vector xsArray = new Vector();
			Vector ysArray = new Vector();
			Iterator i = e.ends().iterator();
			Node n = (Node) (i.next());
			//System.out.println("add "+n);
			double addIntX = n.getPosition().getX();
			double addIntY = n.getPosition().getY();
			xsArray.add(new Double(n.getPosition().getX()));
			ysArray.add(new Double(n.getPosition().getY()));
			//System.out.println("array for xcoords is "+xsArray);
			//System.out.println("array for ycoords is "+ysArray);
			Node firstN = n;
			n = (Node) (i.next());
			//System.out.println("add "+n);
			double newAddIntX = n.getPosition().getX();
			double newAddIntY = n.getPosition().getY();
			//System.out.println("is "+newAddIntX+"!="+addIntX+" || "+newAddIntY+"!="+addIntY+"?");
			if (newAddIntX != addIntX
				|| newAddIntY != addIntY) { //System.out.println("yes");
				xsArray.add(new Double(newAddIntX));
				ysArray.add(new Double(newAddIntY));
				addIntX = newAddIntX;
				addIntY = newAddIntY;
			}
			//System.out.println("array for xcoords is "+xsArray);
			//System.out.println("array for ycoords is "+ysArray);
			boolean haveCompleted = false;
			while (!haveCompleted) { // seek edge between n and next place
				//System.out.println("we have "+edgesCopy.size()+" edges");
				Iterator edgeIt = edgesCopy.iterator();
				edgeSearch : while (edgeIt.hasNext()) {
					e = (Edge) (edgeIt.next());
					//System.out.println("see if "+e+" meets "+n);
					if (e.ends().contains(n)) {
						// decide whether the other end is firstN
						//System.out.println("consider edge "+e);
						if (e.ends().contains(firstN)) {
							haveCompleted = true;
						} else {
							Iterator iends = e.ends().iterator();
							Node nhere = (Node) (iends.next());
							//System.out.print("add "+nhere+"?");
							if (nhere.equals(n)) {
								nhere = (Node) (iends.next());
								//System.out.println("no : add"+nhere);
							}
							//else{ //System.out.println("yes"); }
							newAddIntX = nhere.getPosition().getX();
							newAddIntY = nhere.getPosition().getY();
							if (newAddIntX != addIntX
								|| newAddIntY != addIntY) {
								xsArray.add(new Double(newAddIntX));
								ysArray.add(new Double(newAddIntY));
								addIntX = newAddIntX;
								addIntY = newAddIntY;
							}
							//System.out.println("array for xcoords is "+xsArray);
							//System.out.println("array for ycoords is "+ysArray);
							n = nhere;
						}
						edgesCopy.remove(e);
						break edgeSearch;
					}
				}
			}
			if (xsArray.get(0).equals(xsArray.get(xsArray.size() - 1))
				&& ysArray.get(0).equals(
					ysArray.get(
						ysArray.size() - 1))) {
				//System.out.println("first equals last");
				xsArray.remove(0);
				ysArray.remove(0);
			}
			//System.out.println("Array for xcoords is "+xsArray);
			//System.out.println("Array for ycoords is "+ysArray);
			//System.out.println("has completed? "+haveCompleted);
			int[] xs = new int[xsArray.size()];
			int[] ys = new int[ysArray.size()];
			i = xsArray.iterator();
			Iterator j = ysArray.iterator();
			int index = 0;
			while (i.hasNext()) {
				xs[index] = (int) ((Double) (i.next())).doubleValue();
				ys[index] = (int) ((Double) (j.next())).doubleValue();
				index++;
			}
			Polygon p = new Polygon(xs, ys, xsArray.size());
			//System.out.println("dualiser adds "+p);
			//System.out.println("!!!!!!!!!adding contour labelled "+ e.label());
			result.add(p, (Contour) (e.label()));
		}
		// I have an Vector of zones, parents, and a rwd.views.graph with nodes labelled
		// with Strings. At least I have to count and put right number of holes
		// At best I locate those holes using coords of points
		int posnCounter = 0; // only used for rubbish implementation
		Vector parentsCopy = (Vector) (parents.clone());
		// remove from parenstCopy those zones which aren't here yet
		Vector tmp = new Vector();
		Zone smallestZone = null;
		Iterator pIt = parentsCopy.iterator();
		while (pIt.hasNext()) {
			Zone z = (Zone) (pIt.next());
			Vector resultZones = result.zones();
			boolean zoneIsHere = false;
			Iterator rzi = resultZones.iterator();
			resultZoneSearch : while (rzi.hasNext()) {
				if ((Zone) (rzi.next())==z) {
					zoneIsHere = true;
					break resultZoneSearch;
				}
			}
			if (zoneIsHere) {
				tmp.add(z);
				if (smallestZone == null
					|| smallestZone.getContainingContours().containsAll(z.getContainingContours())) {
					smallestZone = z;
				}
			}
		}
		//tmp.remove(smallestZone);
		parentsCopy = tmp;
		//System.out.println("parentsCopy is "+parentsCopy);
		///////////////////////////////////////////////////////////
		while (parentsCopy.size() > 0) {
			pIt = parentsCopy.iterator();
			Zone z = (Zone) (pIt.next());
			// before inserting a rectangle check
			// that z isn't the smallest zone of block
			parentsCopy.remove(z);
			int numOccs = 1;
			Vector toBeRemoved = new Vector();
			Iterator pIt2 = parentsCopy.iterator();
			while (pIt2.hasNext()) {
				Zone z2 = (Zone) (pIt2.next());
				if (z2==z) {
					numOccs++;
					toBeRemoved.add(z2);
				}
			}
			parentsCopy.removeAll(toBeRemoved);
			// I know that zone z needs numOccs holes.
			//System.out.println("parents are "+parents);
			//System.out.println("and I want to add "+numOccs
			//                               +" hole(s) for zone "+z+" in "+result);
			// find node for zone z in circularised
			int centrex = 0, centrey = 0, radius;
			Iterator cni = circularised.nodes().iterator();
			placeSearch : while (cni.hasNext()) {
				Node n = (Node) (cni.next());
				if (n.label1().equals(z.getContainingContours())) {
					//System.out.println("found somewhere to put rectangle");
					centrex = (int) (n.getPosition().getX() * 1.1);
					centrey = (int) (n.getPosition().getY() * 1.1);
					break placeSearch;
				}
			}
			//System.out.println("circle centre is at "+centrex+","+centrey);
			int numCirclePts = circularised.nodes().size();
			TreeSet tmpt = new TreeSet();
			tmpt.addAll(parentsCopy);
			int numStretched = tmpt.size();
			double alpha = 2 * Math.PI / (numCirclePts + 2 * numStretched);
			radius =
				(int) ((result.getFittedBoundingBox().width)
					* (1 - Math.cos(alpha))
					* 0.6);
			//System.out.println("radius is "+radius);
			//System.out.println("centre at "+centrex+" ,"+centrey);
			for (int holeCounter = 0; holeCounter < numOccs; holeCounter++) {
				int lowx =
					centrex - radius / 2 + holeCounter * (radius / numOccs);
				int lowy = centrey - radius / (2 * numOccs);
				//System.out.println("fitting "+holeCounter+"th square");
				//System.out.println("corner at "+lowx+", "+lowy);
				//System.out.println("radius "+radius/numOccs);
				result.add(
					new Rectangle(
						lowx,
						lowy,
						radius / numOccs,
						radius / numOccs),
					z);
			}
			//System.out.println("after adding rectangle result is now "+result);
			posnCounter++;
		}
		return result;
	}

	private static TreeSet makeZonesFor(TreeSet nodes) {
		TreeSet zones = new TreeSet();
		//System.out.println("making zones for nodes "+nodes);
		Iterator nodeIt = nodes.iterator();
		while (nodeIt.hasNext()) {
			Node n = (Node) (nodeIt.next());
			Vector a = new Vector();
			Vector a2 = new Vector();
			a.addAll(n.label1());
			a2.addAll(n.label2());
			zones.add(Zone.getZone(a,a2));
		}
		return zones;
	}

	private static Position getPosition(
		int posNumber,
		double stepOut) { //return Position.getRadialPosition(2*posnumber+1, 2*totalNum, stepOut);
		//System.out.println("looking for position at "+posNumber);
		Position p1 = Circulariser.getPosition(posNumber);
		Position p2 = null;
		try {
			p2 = Circulariser.getPosition(posNumber + 1);
		} catch (ArrayIndexOutOfBoundsException x) { //System.out.println("wrap around to position at 0");
			p2 = Circulariser.getPosition(0);
		}
		if (p2 == null) { //System.out.println("wrap around to position at 0");
			p2 = Circulariser.getPosition(0);
		}
		//System.out.println("got two positions to average:"+p1+" "+p2);
		double avx = (p1.getX() + p2.getX()) / 2; //NULLPOINTER HERE???!?
		double avy = (p1.getY() + p2.getY()) / 2;
		double length = Math.sqrt(avx * avx + avy * avy);
		if (stepOut > 0) {
			return new Position(
				(int) (avx / length * ConcreteDiagram.SCALE * (1 + stepOut)),
				(int) (avy / length * ConcreteDiagram.SCALE * (1 + stepOut)));
		} else {
			return new Position(avx, avy);
		}
	}

	private static Position getPositionJustBefore(
		int posNumber,
		double stepOut) { //System.out.println("looking for position just before "+posNumber);
		Position p = Circulariser.getPosition(posNumber);
		//System.out.println("got position at "+posNumber);
		int x = (int) (p.getX());
		int y = (int) (p.getY());
		double length = Math.sqrt(x * x + y * y);
		return new Position(
			(int) (x / length * 1000 * (1 + stepOut)),
			(int) (y / length * 1000 * (1 + stepOut)));
	}
}
