package rwd.views.abstracttoconcrete.forcemodel;

import java.io.Serializable;

/**
 * An undirected edge.
 *
 * @author  $Author: op $
 * @version $Id: Edge.java,v 1.5 2004/10/20 10:08:39 op Exp $
 */
public class Edge implements Serializable {
    
    public Edge(Node source, Node target) {
        this(source, target, 1);
    }
    
    public Edge(Node source, Node target, double weight) {
        _source = source;
        _target = target;
        _weight = weight;
    }
    
    public Node getSource() {
        return _source;
    }
    
    public Node getTarget() {
        return _target;
    }
    
    public double getWeight() {
        return _weight;
    }
    
    public int hashCode() {
        return _source.hashCode() + _target.hashCode();
    }
    
    public boolean equals(Object o) {
        Edge edge = (Edge) o;
        return edge.getSource().equals(this.getSource()) && edge.getTarget().equals(this.getTarget()) ||
               edge.getSource().equals(this.getTarget()) && edge.getTarget().equals(this.getSource());
    }
    
    public String toString() {
        return getSource().getLabel() + " ---" + getWeight() + "--- " + getTarget().getLabel();
    }
    
    private Node _source;
    private Node _target;
    private double _weight;
    
}
