package rwd.views.abstracttoconcrete.forcemodel;

import java.io.Serializable;

/**
 * @author  $Author: op $
 * @version $Id: Node.java,v 1.6 2004/10/20 10:08:39 op Exp $
 */
public class Node implements Serializable {
    
    public Node() {
        this("");
    }
    
    public Node(String label) {
        this(label, 1, false);
    }
    
    public Node(String label, double weight, boolean fixed) {
        _label = label;
        _weight = weight;
        _fixed = fixed;
    }
    
    public String getLabel() {
        return _label;
    }
    
    public double getX() {
        return _x;
    }
    
    public double getY() {
        return _y;
    }

    public double getFX() {
        return _fx;
    }
    
    public double getFY() {
        return _fy;
    }
    
    public double getWeight() {
        return _weight;
    }
    
    public boolean isFixed() {
        return _fixed;
    }
    
    public void setX(double x) {
        _x = x;
    }
    
    public void setY(double y) {
        _y = y;
    }

    public void setFX(double fx) {
        _fx = fx;
    }
    
    public void setFY(double fy) {
        _fy = fy;
    }
    
    public Object getObject() {
        return _object;
    }
    
    public void setObject(Object o) {
        _object = o;
    }
    
    public int hashCode() {
        return _label.hashCode();
    }
    
    public boolean equals(Object o) {
        Node node = (Node) o;
        return node.getLabel().equals(this.getLabel());
    }
    
    public String toString() {
        return getLabel() + " (" + getX() + ", " + getY() + ")";
    }
    
    private Object _object = null;
    private String _label;
    private double _weight;
    private boolean _fixed;
    private double _x = 0;
    private double _y = 0;
    private double _fx = 0;
    private double _fy = 0;
    
}
