package rwd.views.graph;
import java.util.Vector;
import java.util.Iterator;
import java.util.TreeSet;

public class BlockNode {

	private Node node;
	private Vector children; // will be a set of BlockGraphs who have
	// this node as their parent
	private BlockGraph parent;
	// will be a rwd.views.graph which contains this node

	public BlockNode(Graph g) { //System.out.println(""+this.hashCode()+":BlockNode constructor has received rwd.views.graph "+g);
		// find the smallest Node
		TreeSet nodes = g.nodes();
		Node n = (Node) (nodes.iterator().next());
		//System.out.println("smallest node of "+g+" is "+n);
		this.children = new Vector();
		this.node = n;
		//System.out.println("setting this node to be "+n);
		BlockGraph child = new BlockGraph(this, g);
		//System.out.println("about to add child:"+child);
		this.children.add(child);
		//System.out.println(""+this.hashCode()+":BlockNode constructor finished");
		//System.out.println("having built "+this);
	}

	public Vector getBlockGraphChildren() {
		return children;
	}

	public BlockNode(Node n, BlockGraph parent) {
		this.node = n;
		this.parent = parent;
		this.children = new Vector();
	}

	public Node node() {
		return node;
	}

	void addChildGraph(BlockGraph bg) {
		children.add(bg);
	}

	public Vector getChildren() {
		return this.children;
	}

	public Vector getBlocks() { //System.out.println("this blockNode "+this);
		//System.out.println("has children "+children);
		Vector result = new Vector();
		result.addAll(this.children);
		Iterator i = getChildren().iterator();
		while (i.hasNext()) {
			BlockGraph bg = (BlockGraph) (i.next());
			Vector bns = bg.children();
			for (int j = 0; j < bns.size(); j++) {
				BlockNode bn = (BlockNode) bns.get(j);
				if (bn != null) {
					result.addAll(bn.getBlocks());
				}
			}
		}
		return result;
	}

	public String toString() {
		return "blockNode:\nnode " + node + " and \nchildren " + children;
	}

/*	public static void main(String[] args) {
		TreeSet nodes = new TreeSet();
		Node n = Node.getNode(new TreeSet());
		nodes.add(n);
		TreeSet labels = new TreeSet();
		labels.add("a");
		Node na = Node.getNode(labels);
		nodes.add(na);
		labels = new TreeSet();
		labels.add("a");
		labels.add("b");
		Node nab = Node.getNode(labels);
		nodes.add(nab);
		labels = new TreeSet();
		labels.add("b");
		Node nb = Node.getNode(labels);
		nodes.add(nb);
		TreeSet edges = new TreeSet();
		edges.add(Edge.getEdge(n, na));
		edges.add(Edge.getEdge(na, nab));
		edges.add(Edge.getEdge(n, nb));
		edges.add(Edge.getEdge(nb, nab));
		Graph g = new Graph(nodes, edges);

		BlockNode bn = new BlockNode(g);
		//System.out.println("topNode is "+bn);
		Vector children = bn.getChildren();
		//System.out.println("has "+children.size()+"children");
		Iterator i = children.iterator();
		while (i.hasNext()) {
			BlockGraph bgc = (BlockGraph) (i.next());
			System.out.println("childNode has child:"+ bgc);
		}
		//System.out.println("all blocks are "+bn.getBlocks());
	}
	*/
}
