package rwd.views.smoother;

import java.awt.Polygon;
import java.awt.Rectangle;
import java.util.Iterator;
import java.util.Set;

import javax.swing.JFrame;

import rwd.concretesyntax.ConcreteUnitaryDiagram;
import rwd.concretesyntax.eulerdiagram.AEDView;
import rwd.concretesyntax.eulerdiagram.ConcreteContour;
import rwd.concretesyntax.eulerdiagram.DecorationBox;
import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerComponent;

public class SmoothingDemo {
	public SmoothingDemo(AEDView aedv, boolean showParameters) {
		int lowX = -2150;
		int lowY = -2150;
		int width = 3400;
		int height = 3400;
		aedv.scaleToFit(
			new Rectangle(
				(int) (lowX + width / 10),
				(int) (lowY + height / 10),
				(int) (width * 0.8),
				(int) (height * 0.8)));
		Set contours = aedv.getConcreteContours();

		Iterator i = contours.iterator();
		while (i.hasNext()) {
			ConcreteContour c = (ConcreteContour) i.next();
			c.getPolygon().invalidate();
			System.out.println("c.bb is " + c.getPolygon().getBoundingBox());
		}

		ConcreteUnitaryDiagram cud =
			new ConcreteUnitaryDiagram(
				new DecorationBox(
					"box",
					"",
					new Polygon(
						new int[] {
							(int) (lowX),
							(int) (lowX),
							(int) (lowX + width),
							(int) (lowX + width)},
						new int[] {
							lowY,
							(int) (lowY + height),
							(int) (lowY + height),
							lowY },
						4)));
		cud.addConcreteContours(contours);
		Iterator it = contours.iterator();
		while (it.hasNext()) {
			Object o = it.next();
			System.out.println(
				"" + ((ConcreteContour) o).getShape().getBounds());
		}

		// Add more points and redraw diagram
		cud.addMorePoints(8);

//		StructureChecker sc = new ZonePresenceChecker();
		// Create the viewer
		DiagramViewerComponent viewer =
			new DiagramViewerComponent(400, 400, true, false);
		viewer.setBezier(false);

		// Create the smoother window and 
		boolean integrateViewer = true;
		MetricSmootherParameterWindow pw =
			new MetricSmootherParameterWindow(
				(EditorFrame) (viewer.getParent()),
				cud,
				viewer,
				integrateViewer);
		if (!integrateViewer) {
			JFrame jf = new JFrame();
			jf.getContentPane().add(viewer);
			jf.pack();
			jf.show();
		}

		// Show parameters
		pw.setVisible(showParameters);
		if (!showParameters) {
			pw.startButton(null);
		}
	}
}
